SystemOrganization addCategory: #'RobotSoccer-Core'!
SystemOrganization addCategory: #'RobotSoccer-Tests'!
SystemOrganization addCategory: #'RobotSoccer-Viewer-Plugins'!
SystemOrganization addCategory: #'RobotSoccer-Viewer'!
SystemOrganization addCategory: #'RobotSoccer-Strategy-Performance'!
SystemOrganization addCategory: #'RobotSoccer-Strategy-Example'!
SystemOrganization addCategory: #'RobotSoccer-Servers'!
SystemOrganization addCategory: #'RobotSoccer-Servers-SimuroSot'!
SystemOrganization addCategory: #'RobotSoccer-Servers-Real-MixedRobots'!
SystemOrganization addCategory: #'RobotSoccer-Servers-Real-LegoNxt'!
SystemOrganization addCategory: #'RobotSoccer-Servers-Real-Doraemon'!
SystemOrganization addCategory: #'RobotSoccer-Servers-Empty'!
SystemOrganization addCategory: #'RobotSoccer-Servers-Real-Nestor'!

EllipseMorph subclass: #BallMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Viewer'!

!BallMorph methodsFor: 'initialize' stamp: 'Richo 10/9/2009 16:25'!
initialize
super initialize.
self extent:  10.675@10.675; color: Color orange! !

Object subclass: #Angle
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Core'!

!Angle class methodsFor: 'instance creation' stamp: 'Richo 6/21/2008 19:57'!
degrees: aNumber 
	^ self basicNew inDegrees: aNumber! !

!Angle class methodsFor: 'instance creation' stamp: 'Richo 11/3/2010 14:40'!
new
^self degrees: 0! !

!Angle class methodsFor: 'instance creation' stamp: 'Richo 6/21/2008 19:57'!
radians: aNumber
^self basicNew inRadians: aNumber! !

!Angle methodsFor: 'arithmetic' stamp: 'Richo 10/25/2010 15:24'!
+ anAngle 
	"Suma manteniendo entre -180 y 180"
	| nuevo |
	nuevo := self degrees + anAngle degrees.
	nuevo > 180
		ifTrue: [nuevo := self degrees - (360 - anAngle degrees)].
	nuevo < -180
		ifTrue: [^ self - anAngle negated].
	^ Angle degrees: nuevo! !

!Angle methodsFor: 'arithmetic' stamp: 'Richo 10/25/2010 15:24'!
- anAngle 
	"Resta manteniendo el valor entre -180 y 180"
	| nuevo |
	nuevo := self degrees - anAngle degrees.
	nuevo < -180
		ifTrue: [nuevo := self degrees + (360 - anAngle degrees)].
	nuevo > 180
		ifTrue: [^ self + anAngle negated].
	^ Angle degrees: nuevo! !

!Angle methodsFor: 'arithmetic' stamp: 'Richo 6/21/2008 20:01'!
< anAngle 
	^ self degrees < anAngle degrees! !

!Angle methodsFor: 'arithmetic' stamp: 'Richo 6/21/2008 20:01'!
= anAngle 
	^ self radians closeTo: anAngle radians! !

!Angle methodsFor: 'arithmetic' stamp: 'Richo 6/21/2008 20:01'!
> anAngle 
	^ self degrees > anAngle degrees! !

!Angle methodsFor: 'accessing' stamp: 'Richo 6/21/2008 19:59'!
degrees
^value radiansToDegrees ! !

!Angle methodsFor: 'arithmetic' stamp: 'Richo 6/21/2008 20:01'!
diff: anAngle 
	| dif |
	dif := self - anAngle.
	^ dif degrees abs! !

!Angle methodsFor: 'initialization' stamp: 'Richo 6/21/2008 19:59'!
inDegrees: aNumber 
	value := aNumber degreesToRadians ! !

!Angle methodsFor: 'initialization' stamp: 'Richo 6/21/2008 19:58'!
inRadians: aNumber
value := aNumber! !

!Angle methodsFor: 'arithmetic' stamp: 'Richo 10/25/2010 15:24'!
negated
	^ Angle degrees: self degrees negated! !

!Angle methodsFor: 'arithmetic' stamp: 'Richo 6/22/2008 22:15'!
opposite
	^ self
		+ (RSAngle degrees: 180)! !

!Angle methodsFor: 'copying' stamp: 'Richo 10/6/2009 12:15'!
postCopy
super postCopy.
value := value copy.! !

!Angle methodsFor: 'printing' stamp: 'Richo 6/23/2008 11:47'!
printOn: aStream 
	super printOn: aStream.
	aStream nextPutAll: '(' , self degrees asString , ' degrees)'! !

!Angle methodsFor: 'accessing' stamp: 'Richo 6/21/2008 19:59'!
radians
	^ value! !

Object subclass: #BallPredictor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Core'!

!BallPredictor methodsFor: 'as yet unclassified' stamp: 'Richo 11/3/2010 16:23'!
ballPositionAt: nFrame on: env 
	| dif |
	dif := env ball position - env previousEnvironmentOrSelf ball position.
	^ env ball position + (dif * nFrame).
	! !

Object subclass: #Environment
	instanceVariableNames: 'field ball homePlayers opponentPlayers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Core'!

Environment class
	instanceVariableNames: 'example'!

Environment class
	instanceVariableNames: 'example'!

!Environment class methodsFor: 'instance creation' stamp: 'Richo 11/16/2010 11:51'!
field: aField ball: aBall homePlayers: anArrayOfPlayers opponentPlayers: anotherArrayOfPlayers
^(self basicNew setField: aField ball: aBall homePlayers: anArrayOfPlayers opponentPlayers: anotherArrayOfPlayers) initialize! !

!Environment methodsFor: 'accessing' stamp: 'Richo 11/3/2010 14:51'!
ball
^ball! !

!Environment methodsFor: 'accessing' stamp: 'Richo 10/26/2010 14:53'!
field
^ field! !

!Environment methodsFor: 'accessing' stamp: 'Richo 11/3/2010 14:50'!
homePlayers
^homePlayers! !

!Environment methodsFor: 'accessing' stamp: 'Richo 11/3/2010 14:51'!
opponentPlayers
^ opponentPlayers ! !

!Environment methodsFor: 'private' stamp: 'Richo 11/16/2010 11:52'!
setField: aField ball: aBall homePlayers: anArrayOfPlayers opponentPlayers: anotherArrayOfPlayers 
field := aField.
ball := aBall.
homePlayers := anArrayOfPlayers.
opponentPlayers := anotherArrayOfPlayers.! !

Object subclass: #Field
	instanceVariableNames: 'vertices bounds'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Core'!

!Field class methodsFor: 'instance creation' stamp: 'Richo 10/25/2010 17:55'!
fromRectangle: aRectangle 
^self vertices: {
aRectangle topLeft.
aRectangle topRight.
aRectangle bottomLeft.
aRectangle bottomRight}! !

!Field class methodsFor: 'instance creation' stamp: 'Richo 10/25/2010 17:55'!
vertices: anArrayOfPoints
^(self basicNew setVertices: anArrayOfPoints) initialize ! !

!Field methodsFor: 'accessing' stamp: 'Richo 10/26/2010 15:14'!
bottom
^self bounds bottom ! !

!Field methodsFor: 'accessing' stamp: 'Richo 10/25/2010 17:57'!
bounds
^bounds ifNil: [bounds := Rectangle encompassing: vertices]! !

!Field methodsFor: 'accessing' stamp: 'Richo 10/25/2010 17:56'!
center
^self bounds center! !

!Field methodsFor: 'accessing' stamp: 'Richo 10/26/2010 15:14'!
left
	^self bounds left! !

!Field methodsFor: 'accessing' stamp: 'Richo 10/26/2010 15:14'!
right
	^self bounds right! !

!Field methodsFor: 'private' stamp: 'Richo 10/25/2010 17:56'!
setVertices: anArray 
vertices := anArray ! !

!Field methodsFor: 'accessing' stamp: 'Richo 10/26/2010 15:14'!
top
^self bounds top! !

!Field methodsFor: 'accessing' stamp: 'Richo 10/26/2010 14:57'!
width
	^self bounds width! !

Object subclass: #FieldTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Tests'!

Object subclass: #Game
	instanceVariableNames: 'videoServer robotServer environment process strategy snapshots'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Core'!

!Game methodsFor: 'initialize-release' stamp: 'Richo 11/16/2010 12:20'!
initialize
	snapshots := OrderedCollection new.! !

!Game methodsFor: 'stepping' stamp: 'Richo 10/21/2009 14:42'!
isPaused
process notNil ifTrue: [^process isSuspended].
^false! !

!Game methodsFor: 'stepping' stamp: 'Richo 10/20/2009 12:24'!
isStepping
^self isStopped not and: [self isPaused not]! !

!Game methodsFor: 'stepping' stamp: 'Richo 10/21/2009 14:42'!
isStopped
process notNil ifTrue: [^process isTerminated].
^true
! !

!Game methodsFor: 'stepping' stamp: 'Richo 7/12/2008 21:39'!
pause
process ifNotNil: [
	process suspend]! !

!Game methodsFor: 'actions' stamp: 'Richo 10/27/2009 12:05'!
removeRobotServer
	self stop.
	robotServer
		ifNotNil: [robotServer disconnect.
			robotServer := nil]! !

!Game methodsFor: 'actions' stamp: 'Richo 11/3/2010 17:52'!
removeStrategy
	self stop.
	strategy 
		ifNotNil: [strategy := nil]! !

!Game methodsFor: 'actions' stamp: 'Richo 10/27/2009 12:05'!
removeVideoServer
	self stop.
	videoServer
		ifNotNil: [videoServer disconnect.
			videoServer := nil]! !

!Game methodsFor: 'accessing' stamp: 'Richo 11/3/2010 15:16'!
robotServer
	^ robotServer! !

!Game methodsFor: 'accessing' stamp: 'Richo 11/16/2010 11:42'!
robotServer: aRobotServer
	self removeRobotServer.
	robotServer := aRobotServer.! !

!Game methodsFor: 'stepping' stamp: 'Richo 11/16/2010 11:55'!
start
	videoServer ifNil: [^self error: 'Video server not selected'].
	robotServer ifNil: [^self error: 'Robot server not selected'].
	strategy ifNil: [^self error: 'Strategy not selected'].
	process
		ifNotNil: [process resume.
			^ self].
	process := [ | delay | delay := (Delay forMilliseconds: 1).
				[true]
				whileTrue: [self step. delay wait]]
				forkNamed: self class asString! !

!Game methodsFor: 'stepping' stamp: 'Richo 11/16/2010 12:20'!
step
	| currentEnv team |
	currentEnv := videoServer currentEnvironment.
	team := robotServer currentTeam.
	strategy applyOn: team for: currentEnv.
	robotServer sendDataOf: team. 
	snapshots add: (GameSnapshot environment: currentEnv team: team).! !

!Game methodsFor: 'stepping' stamp: 'Richo 7/12/2008 22:34'!
stop
	process
		ifNotNil: [process terminate. process := nil]! !

!Game methodsFor: 'accessing' stamp: 'Richo 11/3/2010 16:10'!
strategy
^strategy ! !

!Game methodsFor: 'accessing' stamp: 'Richo 11/16/2010 11:54'!
strategy: aStrategy
	self removeStrategy.
	strategy := aStrategy ! !

!Game methodsFor: 'accessing' stamp: 'Richo 11/3/2010 15:16'!
videoServer
	^ videoServer! !

!Game methodsFor: 'accessing' stamp: 'Richo 11/3/2010 15:16'!
videoServer: aVideoServer
	self removeVideoServer.
	videoServer := aVideoServer ! !

Object subclass: #GameSnapshot
	instanceVariableNames: 'environment team'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Core'!

!GameSnapshot class methodsFor: 'as yet unclassified' stamp: 'Richo 11/16/2010 12:18'!
environment: anEnvironment team: aTeam
^self basicNew setEnvironment: anEnvironment team: aTeam ! !

!GameSnapshot methodsFor: 'accessing' stamp: 'Richo 11/16/2010 12:19'!
environment 
^ environment ! !

!GameSnapshot methodsFor: 'private' stamp: 'Richo 11/16/2010 12:18'!
setEnvironment: anEnvironment team: aTeam
environment := anEnvironment.
team := aTeam ! !

!GameSnapshot methodsFor: 'accessing' stamp: 'Richo 11/16/2010 12:19'!
team
^ team! !

Object subclass: #ImagesHolder
	instanceVariableNames: 'blue yellow'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Viewer'!

!ImagesHolder class methodsFor: 'constants' stamp: 'Richo 10/13/2009 12:14'!
defaultBlue1
^ (Form
	extent: 19@19
	depth: 32
	fromArray: #( 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294901760 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4294901760 4294901760 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4294901760 4294901760 4294901760 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4294901760 4294901760 4294901760 4294901760 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4294901760 4294901760 4294901760 4294901760 4294901760 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335)
	offset: 0@0)! !

!ImagesHolder class methodsFor: 'constants' stamp: 'Richo 10/13/2009 12:14'!
defaultBlue2
^(Form
	extent: 19@19
	depth: 32
	fromArray: #( 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286578816 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286578816 4286578816 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286578816 4286578816 4286578816 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286578816 4286578816 4286578816 4286578816 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286578816 4286578816 4286578816 4286578816 4286578816 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335)
	offset: 0@0)! !

!ImagesHolder class methodsFor: 'constants' stamp: 'Richo 10/13/2009 12:15'!
defaultBlue3
^ (Form
	extent: 19@19
	depth: 32
	fromArray: #( 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294952132 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4294952132 4294952132 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4294952132 4294952132 4294952132 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4294952132 4294952132 4294952132 4294952132 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4294952132 4294952132 4294952132 4294952132 4294952132 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335)
	offset: 0@0)! !

!ImagesHolder class methodsFor: 'constants' stamp: 'Richo 10/13/2009 12:15'!
defaultBlue4
^  (Form
	extent: 19@19
	depth: 32
	fromArray: #( 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278255360 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4278255360 4278255360 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4278255360 4278255360 4278255360 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4278255360 4278255360 4278255360 4278255360 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4278255360 4278255360 4278255360 4278255360 4278255360 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335)
	offset: 0@0)! !

!ImagesHolder class methodsFor: 'constants' stamp: 'Richo 10/13/2009 12:15'!
defaultBlue5
^  (Form
	extent: 19@19
	depth: 32
	fromArray: #( 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4291085567 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4291085567 4291085567 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4291085567 4291085567 4291085567 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4291085567 4291085567 4291085567 4291085567 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4291085567 4291085567 4291085567 4291085567 4291085567 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335)
	offset: 0@0)! !

!ImagesHolder class methodsFor: 'constants' stamp: 'Richo 10/13/2009 12:29'!
defaultNoRobot
^ (Form
	extent: 19@19
	depth: 32
	fromArray: #( 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294901760 4294901760 4294967295 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294967295 4294901760 4294901760 4294967295 4294967295 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294967295 4294967295 4294901760 4294901760 4294967295 4294967295 4294967295 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294967295 4294967295 4294967295 4294901760 4294901760 4294967295 4294967295 4294967295 4294967295 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294967295 4294967295 4294967295 4294967295 4294901760 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294967295 4294967295 4294967295 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294967295 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294967295 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294967295 4294967295 4294967295 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294901760 4294967295 4294967295 4294967295 4294967295 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294967295 4294967295 4294967295 4294967295 4294901760 4294901760 4294967295 4294967295 4294967295 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294967295 4294967295 4294967295 4294901760 4294901760 4294967295 4294967295 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294967295 4294967295 4294901760 4294901760 4294967295 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294967295 4294901760 4294901760 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760)
	offset: 0@0)! !

!ImagesHolder class methodsFor: 'constants' stamp: 'Richo 10/13/2009 12:16'!
defaultYellow1
^ (Form
	extent: 19@19
	depth: 32
	fromArray: #( 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294901760 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4294901760 4294901760 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4294901760 4294901760 4294901760 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4294901760 4294901760 4294901760 4294901760 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4294901760 4294901760 4294901760 4294901760 4294901760 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040)
	offset: 0@0)! !

!ImagesHolder class methodsFor: 'constants' stamp: 'Richo 10/13/2009 12:17'!
defaultYellow2
^  (Form
	extent: 19@19
	depth: 32
	fromArray: #( 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286578816 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286578816 4286578816 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286578816 4286578816 4286578816 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286578816 4286578816 4286578816 4286578816 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286578816 4286578816 4286578816 4286578816 4286578816 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040)
	offset: 0@0)! !

!ImagesHolder class methodsFor: 'constants' stamp: 'Richo 10/13/2009 12:17'!
defaultYellow3
^  (Form
	extent: 19@19
	depth: 32
	fromArray: #( 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294952132 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4294952132 4294952132 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4294952132 4294952132 4294952132 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4294952132 4294952132 4294952132 4294952132 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4294952132 4294952132 4294952132 4294952132 4294952132 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040)
	offset: 0@0)! !

!ImagesHolder class methodsFor: 'constants' stamp: 'Richo 10/13/2009 12:18'!
defaultYellow4
^ (Form
	extent: 19@19
	depth: 32
	fromArray: #( 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278255360 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4278255360 4278255360 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4278255360 4278255360 4278255360 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4278255360 4278255360 4278255360 4278255360 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4278255360 4278255360 4278255360 4278255360 4278255360 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040)
	offset: 0@0)! !

!ImagesHolder class methodsFor: 'constants' stamp: 'Richo 10/13/2009 12:18'!
defaultYellow5
^  (Form
	extent: 19@19
	depth: 32
	fromArray: #( 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4291085567 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4291085567 4291085567 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4291085567 4291085567 4291085567 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4291085567 4291085567 4291085567 4291085567 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4291085567 4291085567 4291085567 4291085567 4291085567 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040)
	offset: 0@0)! !

!ImagesHolder methodsFor: 'accessing' stamp: 'Richo 10/13/2009 12:32'!
blueImageAt: aNumber
^blue at: aNumber ifAbsent: [self class defaultNoRobot]! !

!ImagesHolder methodsFor: 'accessing' stamp: 'Richo 10/13/2009 12:48'!
blueImageAt: aNumber put: aForm
^blue at: aNumber put: aForm! !

!ImagesHolder methodsFor: 'initialize-release' stamp: 'Richo 10/13/2009 12:31'!
initialize
blue := {self class defaultBlue1. 
self class defaultBlue2.
self class defaultBlue3.
self class defaultBlue4.
self class defaultBlue5.}.
yellow := {self class defaultYellow1.
self class defaultYellow2.
self class defaultYellow3.
self class defaultYellow4.
self class defaultYellow5.}! !

!ImagesHolder methodsFor: 'accessing' stamp: 'Richo 10/13/2009 12:32'!
yellowImageAt: aNumber
^yellow at: aNumber ifAbsent: [self class defaultNoRobot]! !

!ImagesHolder methodsFor: 'accessing' stamp: 'Richo 10/13/2009 12:48'!
yellowImageAt: aNumber put: aForm
^yellow at: aNumber put: aForm! !

Object subclass: #MoveableObject
	instanceVariableNames: 'rotation position founded'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Core'!

!MoveableObject class methodsFor: 'as yet unclassified' stamp: 'Richo 11/3/2010 14:39'!
position: aPoint founded: aBoolean
^self position: aPoint rotation: Angle new founded: aBoolean ! !

!MoveableObject class methodsFor: 'as yet unclassified' stamp: 'Richo 11/3/2010 14:38'!
position: aPoint rotation: anAngle founded: aBoolean
^(self basicNew setPosition: aPoint rotation: anAngle founded: aBoolean) initialize ! !

!MoveableObject methodsFor: 'accessing' stamp: 'Richo 11/3/2010 14:48'!
founded
	^ founded! !

!MoveableObject methodsFor: 'accessing' stamp: 'Richo 11/3/2010 14:48'!
position
	^ position! !

!MoveableObject methodsFor: 'accessing' stamp: 'Richo 11/3/2010 14:48'!
rotation
	^ rotation! !

!MoveableObject methodsFor: 'private' stamp: 'Richo 11/3/2010 15:13'!
setPosition: aPoint rotation: anAngle founded: aBoolean
position := aPoint.
rotation := anAngle.
founded := aBoolean ! !

Object subclass: #NavigatorExample
	instanceVariableNames: 'robot environment index player'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Strategy-Example'!

!NavigatorExample class methodsFor: 'instance creation' stamp: 'tera 11/16/2010 11:11'!
robot: aRobot player: aMoveableObject environment: anEnvironment 
^(self basicNew setRobot: aRobot player: aMoveableObject environment: anEnvironment) initialize ! !

!NavigatorExample methodsFor: 'goalkeeper' stamp: 'Richo 10/25/2010 15:24'!
beGoalkeeper
	(self position x - 90) abs > 5
		ifTrue: [^ self moveTo: 90 @ self position y].
	(self rotation
			diff: (Angle degrees: -90))
			> 5
		ifTrue: [^ self lookDown].
	self followBallInY! !

!NavigatorExample methodsFor: 'accessing' stamp: 'Richo 11/3/2010 15:44'!
environment 
^environment! !

!NavigatorExample methodsFor: 'goalkeeper' stamp: 'Richo 11/3/2010 15:52'!
followBallInY
	| pelotaY dif speed |
	pelotaY := self environment ball position y.
	dif := pelotaY - self position y.
	speed := 125.
	pelotaY < 50 & (pelotaY > 30)
		ifTrue: [dif > 1
				ifTrue: ["Esta arriba"
					^ self velocityLeft: speed negated;
						 velocityRight: speed negated].
			dif < -1
				ifTrue: ["Esta abajo"
					^ self velocityLeft: speed;
						 velocityRight: speed]].
	^ self velocityLeft: 0;
		 velocityRight: 0! !

!NavigatorExample methodsFor: 'calculations' stamp: 'Richo 10/25/2010 15:24'!
getAngle: aPoint 
	| ang |
	(self quadrant: aPoint)
			= 1
		ifTrue: [ang := self getAngleInQuadrant1: aPoint].
	(self quadrant: aPoint)
			= 2
		ifTrue: [ang := self getAngleInQuadrant2: aPoint].
	(self quadrant: aPoint)
			= 3
		ifTrue: [ang := self getAngleInQuadrant3: aPoint].
	(self quadrant: aPoint)
			= 4
		ifTrue: [ang := self getAngleInQuadrant4: aPoint].
	^ Angle degrees: ang! !

!NavigatorExample methodsFor: 'calculations' stamp: 'Richo 6/22/2008 21:57'!
getAngleInQuadrant1: aPoint 
	| dx dy |
	dx := (aPoint x - self position x) abs.
	dy := (aPoint y - self position y) abs.
	dx = 0
		ifTrue: [^ 90.0].
	^ (dy / dx) arcTan radiansToDegrees! !

!NavigatorExample methodsFor: 'calculations' stamp: 'Richo 6/22/2008 21:57'!
getAngleInQuadrant2: aPoint 
	^ 180
		- (self getAngleInQuadrant1: aPoint)! !

!NavigatorExample methodsFor: 'calculations' stamp: 'Richo 6/22/2008 21:57'!
getAngleInQuadrant3: aPoint 
	^ (self getAngleInQuadrant2: aPoint) negated! !

!NavigatorExample methodsFor: 'calculations' stamp: 'Richo 6/22/2008 21:57'!
getAngleInQuadrant4: aPoint 
	^ (self getAngleInQuadrant1: aPoint) negated! !

!NavigatorExample methodsFor: 'calculations' stamp: 'Richo 6/22/2008 21:57'!
isInTheRightSide: aPoint 
	| miAng miOpuesto ang |
	miAng := self rotation.
	miOpuesto := miAng opposite.
	ang := self getAngle: aPoint.
	miAng degrees > 0
		ifTrue: [^ (ang > miAng | (ang < miOpuesto)) not]
		ifFalse: [^ ang < miAng | (ang > miOpuesto)]! !

!NavigatorExample methodsFor: 'calculations' stamp: 'Richo 6/22/2008 21:57'!
isLookingTo: aPoint 
	^ (self lookInFrontOf: aPoint)
		| (self lookBackwardsTo: aPoint)! !

!NavigatorExample methodsFor: 'calculations' stamp: 'Richo 6/22/2008 21:57'!
lookBackwardsTo: aPoint 
	| angulo |
	angulo := self getAngle: aPoint.
	^ (self rotation opposite diff: angulo)
		< 20! !

!NavigatorExample methodsFor: 'goalkeeper' stamp: 'Richo 6/22/2008 21:58'!
lookDown
	| direccion speed |
	direccion := self position x @ (self position y - 20).
	speed := 10.
	(self isInTheRightSide: direccion)
		ifTrue: [self velocityLeft: speed;
				 velocityRight: speed negated]
		ifFalse: [self velocityLeft: speed negated;
				 velocityRight: speed]! !

!NavigatorExample methodsFor: 'calculations' stamp: 'Richo 6/22/2008 21:58'!
lookInFrontOf: aPoint 
	| angulo |
	angulo := self getAngle: aPoint.
	^ (self rotation diff: angulo)
		< 20! !

!NavigatorExample methodsFor: 'navigation' stamp: 'Richo 6/22/2008 21:58'!
moveTo: aPoint 
	(self lookInFrontOf: aPoint)
		ifTrue: [^ self velocityLeft: 125;
				 velocityRight: 125].
	(self lookBackwardsTo: aPoint)
		ifTrue: [^ self velocityLeft: -125;
				 velocityRight: -125].
	(self isInTheRightSide: aPoint)
		ifTrue: [self velocityLeft: 125;
				 velocityRight: 50]
		ifFalse: [self velocityLeft: 50;
				 velocityRight: 125]! !

!NavigatorExample methodsFor: 'navigation' stamp: 'Richo 11/3/2010 15:45'!
moveToBall
	| posPelota |
	posPelota := self environment ball position.
	self position x > posPelota x
		ifTrue: [self moveTo: posPelota]
		ifFalse: [self position y < posPelota y
				ifTrue: [self moveTo: posPelota x + 10 @ (posPelota y - 10)]
				ifFalse: [self moveTo: posPelota x + 10 @ (posPelota y + 10)]]! !

!NavigatorExample methodsFor: 'accessing' stamp: 'Richo 11/3/2010 15:54'!
position
^player position! !

!NavigatorExample methodsFor: 'calculations' stamp: 'Richo 6/22/2008 21:58'!
quadrant: aPoint 
	aPoint x >= self position x
		ifTrue: [aPoint y >= self position y
				ifTrue: [^ 1]
				ifFalse: [^ 4]]
		ifFalse: [aPoint y >= self position y
				ifTrue: [^ 2]
				ifFalse: [^ 3]]! !

!NavigatorExample methodsFor: 'accessing' stamp: 'Richo 11/3/2010 15:55'!
rotation
^player rotation! !

!NavigatorExample methodsFor: 'private' stamp: 'Richo 11/3/2010 15:54'!
setRobot: aRobot player: aMoveableObject environment: anEnvironment 
robot := aRobot.
player := aMoveableObject.
environment := anEnvironment ! !

!NavigatorExample methodsFor: 'accessing' stamp: 'Richo 11/3/2010 15:52'!
velocityLeft: aNumber
robot velocityLeft: aNumber! !

!NavigatorExample methodsFor: 'accessing' stamp: 'Richo 11/3/2010 15:52'!
velocityRight: aNumber
robot velocityRight: aNumber! !

Object subclass: #Robot
	instanceVariableNames: 'velocityLeft velocityRight'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Core'!

!Robot methodsFor: 'accessing' stamp: 'Richo 11/3/2010 15:26'!
velocityLeft
^velocityLeft ! !

!Robot methodsFor: 'accessing' stamp: 'Richo 11/3/2010 15:25'!
velocityLeft: aSmallInteger 
velocityLeft := aSmallInteger ! !

!Robot methodsFor: 'accessing' stamp: 'Richo 11/3/2010 15:27'!
velocityRight
^velocityRight! !

!Robot methodsFor: 'accessing' stamp: 'Richo 11/3/2010 15:25'!
velocityRight: aSmallInteger 
velocityRight := aSmallInteger ! !

Object subclass: #RobotServer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Core'!

RobotServer subclass: #EmptyRobotServer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Servers-Empty'!

!EmptyRobotServer commentStamp: 'Richo 10/25/2010 15:38' prior: 0!
An EmptyRobotServer is simply a RobotServer without robots. It doesn't do anything, it's just for testing.!

!EmptyRobotServer class methodsFor: 'description for viewer' stamp: 'Richo 10/25/2010 15:48'!
descriptionForViewer
^ 'Empty... (just for testing)'! !

!EmptyRobotServer class methodsFor: 'as yet unclassified' stamp: 'Richo 10/23/2009 17:21'!
fromUser
^self new! !

!EmptyRobotServer methodsFor: 'as yet unclassified' stamp: 'Richo 10/23/2009 17:21'!
disconnect
! !

!EmptyRobotServer methodsFor: 'as yet unclassified' stamp: 'Richo 10/23/2009 17:21'!
sendMovesOf: aCollectionOfRobots
! !

RobotServer subclass: #LegoNxtRobotServer
	instanceVariableNames: 'robots'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Servers-Real-LegoNxt'!

!LegoNxtRobotServer class methodsFor: 'description for viewer' stamp: 'Richo 10/25/2010 15:47'!
descriptionForViewer 
^ 'Lego Nxt'! !

!LegoNxtRobotServer class methodsFor: 'as yet unclassified' stamp: 'Richo 10/25/2010 15:46'!
fromUser
| robotServer existingInstances choice |
existingInstances := (LegoNxtMorph allInstances select: [:each | each isInWorld]) sort: [:a :b | a asString < b asString].
existingInstances isEmpty
ifFalse: [
	choice := PopUpMenu withCaption: 'Choose from:' chooseFrom: #(' new... '), (existingInstances collect: [:each|' ',  each asString , ' ']).
	choice = 0 ifTrue: [^nil].
	choice > 1
		ifTrue: [
			^(existingInstances at: choice - 1) robotServer.
			].
	].
robotServer := self new.
(LegoNxtMorph on: robotServer) openInHand.
^robotServer! !

!LegoNxtRobotServer methodsFor: 'converting' stamp: 'Richo 10/28/2009 17:41'!
adapt: aNumber
^aNumber * 100 / 125! !

!LegoNxtRobotServer methodsFor: 'connection' stamp: 'Richo 10/28/2009 17:40'!
connectRobotAt: robotNumber on: portNumber
| lego |
(robots includesKey: robotNumber ) ifFalse: [
	lego := LegoNxt new.
	lego portA plug: NxtMotor new.
	lego portC plug: NxtMotor new.
	robots at: robotNumber put: lego].
(robots at: robotNumber) connectOnPort: portNumber! !

!LegoNxtRobotServer methodsFor: 'connection' stamp: 'Richo 10/30/2009 15:19'!
disconnect
"Para cumplir con el protocolo"
self disconnectAll! !

!LegoNxtRobotServer methodsFor: 'connection' stamp: 'Richo 10/28/2009 17:42'!
disconnectAll
robots valuesDo: [:each| [
		each portA float.
		each portC float.
		each disconnect] on: NotConnectedLego do: [] ].
robots := Dictionary new! !

!LegoNxtRobotServer methodsFor: 'connection' stamp: 'Richo 10/30/2009 15:18'!
disconnectAt: nRobot
| robot |
robot := robots at: nRobot ifAbsent: [^self].
[robot portA float.
robot portC float.
robot disconnect] on: NotConnectedLego do: [].
robot at: nRobot put: nil
! !

!LegoNxtRobotServer methodsFor: 'initialize-release' stamp: 'Richo 10/28/2009 17:17'!
initialize
super initialize.
robots := Dictionary new.! !

!LegoNxtRobotServer methodsFor: 'connection' stamp: 'Richo 10/30/2009 15:19'!
isConnectedAt: nRobot
| robot |
robot := robots at: nRobot ifAbsent: [^false].
^robot isConnected! !

!LegoNxtRobotServer methodsFor: 'sending' stamp: 'Richo 10/28/2009 17:30'!
sendMovesOf: aCollectionOfRobots
| robot lego |
1 to: aCollectionOfRobots size do: [:i|
	robot := aCollectionOfRobots at: i.
	lego := (robots at: i).
	lego portC pluggedDevice power: (self adapt: robot velocityLeft).
	lego portA pluggedDevice power: (self adapt: robot velocityRight).
	]! !

RobotServer subclass: #NestorRobotServer
	instanceVariableNames: 'socket port lastTimeSent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Servers-Real-Nestor'!

NestorRobotServer class
	instanceVariableNames: 'lastPort'!

NestorRobotServer class
	instanceVariableNames: 'lastPort'!

!NestorRobotServer class methodsFor: 'description for viewer' stamp: 'Richo 10/25/2010 15:48'!
descriptionForViewer 
^ 'Nestor robots'! !

!NestorRobotServer class methodsFor: 'instance creation' stamp: 'Richo 10/20/2009 11:26'!
fromUser
	| port |
	port := (FillInTheBlank request: 'Port:' initialAnswer: self lastPort asString) asInteger.
	^ self port: port! !

!NestorRobotServer class methodsFor: 'instance creation' stamp: 'Richo 10/20/2009 11:26'!
lastPort
^lastPort ifNil: [6]! !

!NestorRobotServer class methodsFor: 'instance creation' stamp: 'Richo 10/20/2009 11:20'!
new
^self shouldNotImplement! !

!NestorRobotServer class methodsFor: 'instance creation' stamp: 'Richo 10/20/2009 11:26'!
port: portNumber
lastPort := portNumber.
^(self basicNew setPort: portNumber) initialize.! !

!NestorRobotServer methodsFor: 'converting' stamp: 'Richo 10/27/2009 16:26'!
adapt: aVelocity
aVelocity = 0
	ifTrue: [^0].
aVelocity >= 0
		ifTrue: [^100]
		ifFalse: [^200]! !

!NestorRobotServer methodsFor: 'initialize-release' stamp: 'Richo 10/20/2009 11:23'!
disconnect
port close.
port := nil.! !

!NestorRobotServer methodsFor: 'initialize-release' stamp: 'Richo 10/27/2009 16:29'!
initialize
super initialize.
lastTimeSent := Time millisecondClockValue! !

!NestorRobotServer methodsFor: 'accessing' stamp: 'Richo 10/20/2009 11:23'!
isConnected
^port notNil! !

!NestorRobotServer methodsFor: 'printing' stamp: 'Richo 10/20/2009 11:24'!
printOn: aStream 
	super printOn: aStream.
	aStream nextPutAll: '(' , port asString , ')'! !

!NestorRobotServer methodsFor: 'sending' stamp: 'Richo 10/27/2009 16:28'!
sendMovesOf: aCollectionOfRobots
| msg |
Time millisecondClockValue - lastTimeSent < 50
ifTrue: [^self].
msg := ''.
1 to: 4 do: [:i |
	msg := msg , (Character value: (self adapt: (aCollectionOfRobots at: i) velocityLeft )) asString,
	(Character value: (self adapt: (aCollectionOfRobots at: i) velocityRight )) asString,
	(Character value: 0) asString
	].
msg := msg , Character cr asString.
port nextPutAll: msg.
lastTimeSent := Time millisecondClockValue.! !

!NestorRobotServer methodsFor: 'private' stamp: 'Richo 10/21/2009 17:50'!
setPort: portNumber
	port := SerialPort new
			baudRate: 9600;
			parityType: 0;
			dataBits: 8;
			openPort: portNumber! !

!RobotServer class methodsFor: 'description for viewer' stamp: 'Richo 10/25/2010 15:34'!
descriptionForViewer
^self name! !

!RobotServer class methodsFor: 'instance creation' stamp: 'Richo 7/14/2008 12:48'!
fromUser
	"Pide los datos necesarios al usuario y crea el objeto cargando los datos
	necesarios"
	^ self subclassResponsibility! !

!RobotServer methodsFor: 'abstract' stamp: 'Richo 11/16/2010 11:48'!
currentTeam
"Should return a team with a collection of robots"
^ self subclassResponsibility ! !

!RobotServer methodsFor: 'abstract' stamp: 'Richo 11/16/2010 11:50'!
sendDataOf: aTeam
	"This method should go through the collection of robots and send the motor speed of each robot"
	self subclassResponsibility! !

RobotServer subclass: #SimuroSotRobotServer
	instanceVariableNames: 'socket ip port'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Servers-SimuroSot'!

SimuroSotRobotServer class
	instanceVariableNames: 'lastIp lastPort'!

SimuroSotRobotServer class
	instanceVariableNames: 'lastIp lastPort'!

!SimuroSotRobotServer class methodsFor: 'description for viewer' stamp: 'Richo 10/25/2010 15:59'!
descriptionForViewer
^ 'SimuroSot'! !

!SimuroSotRobotServer class methodsFor: 'instance creation' stamp: 'Richo 7/9/2008 22:49'!
fromUser
	| ip port |
	ip := FillInTheBlank request: 'IP:' initialAnswer: self lastIp.
	port := (FillInTheBlank request: 'Port:' initialAnswer: self lastPort asString) asInteger.
	^ self ip: ip port: port! !

!SimuroSotRobotServer class methodsFor: 'instance creation' stamp: 'Richo 10/20/2009 11:18'!
ip: aString port: aSmallInteger 
lastIp := aString.
lastPort := aSmallInteger.
^ (self basicNew setIp: aString setPort: aSmallInteger) initialize! !

!SimuroSotRobotServer class methodsFor: 'instance creation' stamp: 'Richo 7/9/2008 22:49'!
lastIp
^lastIp ifNil: ['localhost']! !

!SimuroSotRobotServer class methodsFor: 'instance creation' stamp: 'Richo 7/9/2008 22:49'!
lastPort
^lastPort ifNil: [6363]! !

!SimuroSotRobotServer class methodsFor: 'instance creation' stamp: 'Richo 11/3/2010 14:58'!
new
^self ip: self lastIp port: self lastPort! !

!SimuroSotRobotServer methodsFor: 'creating team' stamp: 'Richo 11/16/2010 11:49'!
currentTeam 
^Team robots: ((1 to: 5) collect: [:n | Robot new])
	! !

!SimuroSotRobotServer methodsFor: 'initialize-release' stamp: 'Richo 6/22/2008 17:44'!
disconnect

	socket closeAndDestroy! !

!SimuroSotRobotServer methodsFor: 'initialize-release' stamp: 'Richo 11/16/2010 11:49'!
initialize
	super initialize.
	socket := Socket newUDP.! !

!SimuroSotRobotServer methodsFor: 'printing' stamp: 'Richo 7/12/2008 23:28'!
printOn: aStream 
	super printOn: aStream.
	aStream nextPutAll: '(' , ip , ', ' , port asString , ')'! !

!SimuroSotRobotServer methodsFor: 'sending' stamp: 'Richo 11/16/2010 11:49'!
sendDataOf: aTeam
	| str |

	str := ''.
	aTeam
		do: [:r | str := str , r velocityLeft asString , ' ' , r velocityRight asString , ' '].
	socket
		sendData: str
		toHost: (NetNameResolver addressForName: ip)
		port: port! !

!SimuroSotRobotServer methodsFor: 'private' stamp: 'Richo 6/21/2008 19:09'!
setIp: aString setPort: aSmallInteger 
ip:= aString.
port := aSmallInteger ! !

Object subclass: #Strategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Core'!

!Strategy class methodsFor: 'description for viewer' stamp: 'Richo 10/25/2010 15:34'!
descriptionForViewer
^self name! !

!Strategy class methodsFor: 'instance creation' stamp: 'Richo 10/30/2009 17:57'!
fromUser
^self new! !

!Strategy methodsFor: 'strategy' stamp: 'Richo 11/3/2010 15:17'!
applyOn: aTeam for: anEnvironment
self subclassResponsibility ! !

Strategy subclass: #StrategyExample
	instanceVariableNames: 'a'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Strategy-Example'!

!StrategyExample class methodsFor: 'description for viewer' stamp: 'Richo 11/16/2010 11:24'!
descriptionForViewer 
^ 'Example Strategy'! !

!StrategyExample class methodsFor: 'factory' stamp: 'Richo 10/25/2010 15:30'!
robotClass
^RobotExample! !

!StrategyExample methodsFor: 'strategy' stamp: 'tera 11/16/2010 11:10'!
applyOn: aTeam for: anEnvironment 
	| robots |
	robots := aTeam
				collectWithIndex: [:robot :index | NavigatorExample
						robot: robot
						player: (anEnvironment homePlayers at: index)
						environment: anEnvironment].
	robots
		do: [:each | each moveToBall]. 
	robots first beGoalkeeper! !

Strategy subclass: #TeamPerformance
	instanceVariableNames: 'times'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Strategy-Performance'!

!TeamPerformance class methodsFor: 'description for viewer' stamp: 'Richo 10/25/2010 15:45'!
descriptionForViewer 
^ 'Performance team (just for testing)'! !

!TeamPerformance methodsFor: 'as yet unclassified' stamp: 'Richo 3/31/2009 17:41'!
getAverage
^self getDiff average asFloat! !

!TeamPerformance methodsFor: 'as yet unclassified' stamp: 'Richo 3/31/2009 17:04'!
getDiff
	| aux diff |
	aux := times first.
	diff := OrderedCollection new.
	times allButFirst
		do: [:each | 
			diff add: each - aux.
			aux := each].
	^ diff ! !

!TeamPerformance methodsFor: 'as yet unclassified' stamp: 'Richo 3/31/2009 17:03'!
initialize
	super initialize.
	times := OrderedCollection new.
! !

!TeamPerformance methodsFor: 'as yet unclassified' stamp: 'Richo 3/31/2009 17:18'!
strategyFor: env 

	times add: Time millisecondClockValue.
	env home
		do: [:each | each velocityLeft: 125;
				 velocityRight: -125]! !

Object subclass: #Team
	instanceVariableNames: 'robots'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Core'!

!Team class methodsFor: 'instance creation' stamp: 'Richo 11/3/2010 15:22'!
robots: anArray 
^(self basicNew setRobots: anArray) initialize  ! !

!Team methodsFor: 'collection protocol' stamp: 'Richo 11/16/2010 12:07'!
at: index
^ robots at: index! !

!Team methodsFor: 'collection protocol' stamp: 'Richo 11/3/2010 15:45'!
collect: aBlockClosure 
^robots collect: aBlockClosure! !

!Team methodsFor: 'collection protocol' stamp: 'Richo 11/3/2010 15:51'!
collectWithIndex: aBlockClosure 
^robots collectWithIndex: aBlockClosure ! !

!Team methodsFor: 'collection protocol' stamp: 'Richo 11/16/2010 12:16'!
do: aBlockClosure 
^ robots do: aBlockClosure ! !

!Team methodsFor: 'dnu' stamp: 'Richo 11/16/2010 12:40'!
doesNotUnderstand: aMessage
"This is just a temporary hack to make Team behave like a collection. If you send a message that belongs to the collection protocol, it will try to compile it."
| invalidSelectors |
invalidSelectors := #(#at:put #atAllPut: #atAll:putAll: #atAll:put: #atLast:put: #atWrap:put: #at:incrementBy: #from:to:put: #integerAt:put: #replace: #replaceAll:with: #replaceFrom:to:with: #replaceFrom:to:with:startingAt: #swap:with: #add: #fillFrom:with: #remove: #removeAt: #remove:ifAbsent: #removeAll #removeAll: #removeAllFoundIn: #removeAllSuchThat: #add:withOccurrences: #addAll: #addIfNotPresent: #shuffleBy:).
((robots respondsTo: aMessage selector) and: [(invalidSelectors includes: aMessage selector) not])
	ifTrue: [ | str |
		str := aMessage createStubMethod allButLast: 24.
		self class compile: str, '^ robots ', str classified: #'collection protocol'.
		^aMessage sentTo: self.
		]
	ifFalse: [^super doesNotUnderstand: aMessage]! !

!Team methodsFor: 'collection protocol' stamp: 'Richo 11/16/2010 12:07'!
fifth
	^ robots fifth
	! !

!Team methodsFor: 'collection protocol' stamp: 'Richo 11/3/2010 17:54'!
first
^robots first! !

!Team methodsFor: 'collection protocol' stamp: 'Richo 11/16/2010 12:07'!
fourth
	^ robots fourth
	! !

!Team methodsFor: 'collection protocol' stamp: 'Richo 11/16/2010 12:06'!
second
	^ robots second
	! !

!Team methodsFor: 'collection protocol' stamp: 'Richo 11/16/2010 12:35'!
select: aBlockClosure 
	^ robots select: aBlockClosure 
	! !

!Team methodsFor: 'private' stamp: 'Richo 11/3/2010 15:23'!
setRobots: anArray 
robots := anArray ! !

!Team methodsFor: 'collection protocol' stamp: 'Richo 11/16/2010 12:07'!
third
	^ robots third
	! !

Object subclass: #VideoServer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Core'!

VideoServer subclass: #DoraemonVideoServer
	instanceVariableNames: 'socket fieldBounds goalBounds isYellowTeam predictor'
	classVariableNames: 'LastFieldBounds LastGoalBounds LastPort'
	poolDictionaries: ''
	category: 'RobotSoccer-Servers-Real-Doraemon'!

DoraemonVideoServer class
	instanceVariableNames: 'lastPort'!

DoraemonVideoServer class
	instanceVariableNames: 'lastPort'!

!DoraemonVideoServer class methodsFor: 'description for viewer' stamp: 'Richo 10/25/2010 15:47'!
descriptionForViewer 
^ 'Doraemon'! !

!DoraemonVideoServer class methodsFor: 'instance creation' stamp: 'Richo 10/25/2010 15:47'!
fromUser
| videoServer existingInstances choice |
existingInstances := (DoraemonMorph allInstances select: [:each | each isInWorld]) sort: [:a :b | a asString < b asString].
existingInstances isEmpty
ifFalse: [
	choice := PopUpMenu withCaption: 'Choose from:' chooseFrom: #(' new... '), (existingInstances collect: [:each|' ',  each asString , ' ']).
	choice = 0 ifTrue: [^nil].
	choice > 1
		ifTrue: [
			^(existingInstances at: choice - 1) videoServer.
			].
	].
videoServer := self new.
(DoraemonMorph videoServer: videoServer) openInHand.
^videoServer! !

!DoraemonVideoServer class methodsFor: 'accessing' stamp: 'Richo 10/26/2009 16:33'!
lastFieldBounds
^LastFieldBounds ifNil: [(6.81@77.23) corner: (93.42@6.37)]! !

!DoraemonVideoServer class methodsFor: 'accessing' stamp: 'Richo 10/26/2009 16:34'!
lastGoalBounds
^LastGoalBounds ifNil: [(2.87@49.68) corner: (97.36@33.93)]! !

!DoraemonVideoServer class methodsFor: 'accessing' stamp: 'Richo 10/26/2009 16:32'!
lastPort
	^ LastPort
		ifNil: [6364]! !

!DoraemonVideoServer methodsFor: 'connection' stamp: 'Richo 10/27/2009 14:08'!
connectOnPort: portNumber
LastPort := portNumber.
self disconnect.
socket := (Socket newUDP setPort: portNumber)! !

!DoraemonVideoServer methodsFor: 'connection' stamp: 'Richo 10/26/2009 16:09'!
disconnect
self isConnected ifTrue:[
	socket closeAndDestroy.
	socket := nil]! !

!DoraemonVideoServer methodsFor: 'accessing' stamp: 'Richo 10/26/2009 16:36'!
fieldBounds: aRectangle
LastFieldBounds := aRectangle.
fieldBounds := aRectangle! !

!DoraemonVideoServer methodsFor: 'receiving' stamp: 'Richo 10/27/2009 14:15'!
getData
	| data |
	data := String new: 512.
	socket waitForData; receiveDataInto: data.
	^ data! !

!DoraemonVideoServer methodsFor: 'accessing' stamp: 'Richo 10/26/2009 16:36'!
goalBounds: aRectangle
LastGoalBounds := aRectangle.
goalBounds := aRectangle! !

!DoraemonVideoServer methodsFor: 'inverting field' stamp: 'Richo 10/30/2009 17:33'!
ifYellowTeamInvertFieldOf: env
	isYellowTeam
		ifTrue: [self invertFieldOf: env]! !

!DoraemonVideoServer methodsFor: 'initialize-release' stamp: 'Richo 10/25/2010 15:25'!
initialize
super initialize.
predictor := BallPredictor new.! !

!DoraemonVideoServer methodsFor: 'connection' stamp: 'Richo 9/29/2009 17:21'!
isConnected
^socket notNil! !

!DoraemonVideoServer methodsFor: 'accessing' stamp: 'Richo 10/30/2009 17:03'!
isYellowTeam: aBoolean
isYellowTeam:=aBoolean! !

!DoraemonVideoServer methodsFor: 'printing' stamp: 'Richo 10/26/2009 17:34'!
printOn: aStream
super printOn: aStream.
self isConnected ifTrue: [aStream nextPutAll: '(' , socket port asString , ')']! !

!DoraemonVideoServer methodsFor: 'parsing' stamp: 'Richo 10/25/2010 13:44'!
setBallPropertiesOf: env from: aCollection 
	| founded position |
	founded := (aCollection at: 3)
			= 'Found'.
	env currentBall founded: founded.
	founded ifTrue: [
	position := (aCollection at: 4) asNumber @ (aCollection at: 5) asNumber]
ifFalse: [position := predictor ballPositionAt: 1 on: (env previousEnvironment ifNil: [env])].
	env currentBall position: position.! !

!DoraemonVideoServer methodsFor: 'parsing' stamp: 'Richo 10/25/2010 15:24'!
setRobotPropertiesOf: env from: aCollection 
	| name robotNumber robot founded |
	name := aCollection second.
	robotNumber := name asInteger + 1.
	founded := (aCollection at: 3)
				= 'Found'.
	(name startsWith: 'y')
		ifTrue: [robot := isYellowTeam
						ifTrue: [env homeAt: robotNumber]
						ifFalse: [env opponentAt: robotNumber]]
		ifFalse: [robot := isYellowTeam
						ifTrue: [env opponentAt: robotNumber]
						ifFalse: [env homeAt: robotNumber]].
	founded
		ifTrue: [robot position: (aCollection at: 4) asNumber @ (aCollection at: 5) asNumber.
	robot
		rotation: (Angle radians: (aCollection at: 7) asNumber)].
	robot founded: founded! !

!DoraemonVideoServer methodsFor: 'parsing' stamp: 'Richo 10/26/2010 15:02'!
storeDataOn: env 
	| data parser variable resultado first |
	self isConnected ifFalse: [^self].
	data := self getData.
	parser := TextDiffBuilder new.
	variable := parser split: data by: Character lf.
	resultado := variable
				collect: [:each | parser split: each by: Character space].
	3 to: resultado size do: [:i|
		first := (resultado at: i) at: 1.
		first = '1'
			ifTrue: [self setBallPropertiesOf: env from: (resultado at: i)]
			ifFalse: [self setRobotPropertiesOf: env from: (resultado at: i)].
		].
	env
		field: (Field fromRectangle: fieldBounds).
	env
		goalBounds: (goalBounds).
	self ifYellowTeamInvertFieldOf: env.! !

DoraemonVideoServer subclass: #FakeDoraemonVideoServer
	instanceVariableNames: 'rnd'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Servers-Real-Doraemon'!

!FakeDoraemonVideoServer class methodsFor: 'description for viewer' stamp: 'Richo 10/25/2010 15:48'!
descriptionForViewer 
^ 'Fake Doraemon (just for testing)'! !

!FakeDoraemonVideoServer methodsFor: 'receiving' stamp: 'Richo 10/27/2009 14:23'!
getData
| data |
data := super getData.
^self inDoraemonFormat: data.! !

!FakeDoraemonVideoServer methodsFor: 'formatting' stamp: 'Richo 11/2/2009 15:15'!
inDoraemonFormat: aString 
	| data parser variable resultado newData |
	data := aString.
	parser := TextDiffBuilder new.
	variable := parser split: data by: Character lf.
	resultado := variable
				collect: [:each | parser split: each by: Character space]. 
	newData := WriteStream on: ''.
	self printDoraemonHeaderOn: newData.
	self printBallInfoFrom: resultado on: newData.
	self printRobotsInfoFrom: resultado on: newData.
	self printOpponentsInfoFrom: resultado on: newData.
	^ newData contents! !

!FakeDoraemonVideoServer methodsFor: 'initialize-release' stamp: 'Richo 10/26/2009 14:20'!
initialize
super initialize.
rnd := Random new! !

!FakeDoraemonVideoServer methodsFor: 'formatting' stamp: 'Richo 11/2/2009 15:14'!
printBallInfoFrom: resultado on: newData
	rnd next < self uncertainty
		ifTrue: [newData nextPutAll: '1 ball NoFnd 0.0 0.0 0 0 0 0';
				 nextPut: Character lf]
		ifFalse: [newData nextPutAll: '1 ball Found '
					, ((resultado at: 1)
							at: 1) , ' '
					, ((resultado at: 1)
							at: 2) , ' 0 0 0 0';
				 nextPut: Character lf].! !

!FakeDoraemonVideoServer methodsFor: 'formatting' stamp: 'Richo 11/2/2009 15:13'!
printDoraemonHeaderOn: newData
	newData nextPutAll: '0 0 0';
		 nextPut: Character lf;
		 nextPutAll: '0 0 0';
		 nextPut: Character lf.! !

!FakeDoraemonVideoServer methodsFor: 'formatting' stamp: 'Richo 11/2/2009 16:42'!
printOpponentsInfoFrom: resultado on: newData 
	1
		to: 5
		do: [:i | rnd next < self uncertainty
				ifTrue: [newData nextPutAll: '0 '
							, (isYellowTeam
									ifTrue: ['b']
									ifFalse: ['y']) , (i - 1) asString , ' NoFnd 0.0 0.0 0 0 0 0';
						 nextPut: Character lf]
				ifFalse: [newData nextPutAll: '0 '
							, (isYellowTeam
									ifTrue: ['b']
									ifFalse: ['y']) , (i - 1) asString , ' Found '
							, ((resultado at: i + 6)
									at: 1) , ' '
							, ((resultado at: i + 6)
									at: 2) , ' 0 ' , ((resultado at: i + 6)
								at: 4) asNumber degreesToRadians asString , ' 0 0';
						 nextPut: Character lf]]! !

!FakeDoraemonVideoServer methodsFor: 'formatting' stamp: 'Richo 11/2/2009 15:17'!
printRobotsInfoFrom: resultado on: newData 
	1
		to: 5
		do: [:i | rnd next < self uncertainty
				ifTrue: [newData nextPutAll: '0 '
							, (isYellowTeam
									ifTrue: ['y']
									ifFalse: ['b']) , (i - 1) asString , ' NoFnd 0.0 0.0 0 0 0 0';
						 nextPut: Character lf] 
				ifFalse: [newData nextPutAll: '0 '
							, (isYellowTeam
									ifTrue: ['y']
									ifFalse: ['b']) , (i - 1) asString , ' Found '
							, ((resultado at: i + 1)
									at: 1) , ' '
							, ((resultado at: i + 1)
									at: 2) , ' 0 ' , ((resultado at: i + 1)
								at: 4) asNumber degreesToRadians asString , ' 0 0';
						 nextPut: Character lf]]! !

!FakeDoraemonVideoServer methodsFor: 'accessing' stamp: 'Richo 10/26/2010 15:09'!
uncertainty
	^ 0.4! !

VideoServer subclass: #EmptyVideoServer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Servers-Empty'!

!EmptyVideoServer commentStamp: 'Richo 10/25/2010 15:38' prior: 0!
An EmptyVideoServer is simply a VideoServer without input from a camera. It doesn't do anything, it's just for testing.!

!EmptyVideoServer class methodsFor: 'description for viewer' stamp: 'Richo 10/25/2010 15:48'!
descriptionForViewer
^ 'Empty... (just for testing)'! !

!EmptyVideoServer class methodsFor: 'as yet unclassified' stamp: 'Richo 10/23/2009 18:09'!
fieldBounds
^0@0 corner: 1@1! !

!EmptyVideoServer class methodsFor: 'as yet unclassified' stamp: 'Richo 10/23/2009 18:09'!
fromUser
^self new! !

!EmptyVideoServer methodsFor: 'as yet unclassified' stamp: 'Richo 10/23/2009 18:10'!
disconnect
! !

!EmptyVideoServer methodsFor: 'as yet unclassified' stamp: 'Richo 10/23/2009 18:09'!
storeDataOn: anEnvironment
! !

VideoServer subclass: #SimuroSotVideoServer
	instanceVariableNames: 'socket isYellowTeam'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Servers-SimuroSot'!

SimuroSotVideoServer class
	instanceVariableNames: 'lastPort'!

SimuroSotVideoServer class
	instanceVariableNames: 'lastPort'!

!SimuroSotVideoServer class methodsFor: 'constants' stamp: 'Richo 6/21/2008 19:27'!
anyonesBall
	^ 0! !

!SimuroSotVideoServer class methodsFor: 'constants' stamp: 'Richo 6/21/2008 19:27'!
blueBall
	^ 1! !

!SimuroSotVideoServer class methodsFor: 'description for viewer' stamp: 'Richo 10/25/2010 15:59'!
descriptionForViewer
^ 'SimuroSot'! !

!SimuroSotVideoServer class methodsFor: 'constants' stamp: 'Richo 4/1/2009 14:20'!
fieldBounds
	^ ( 6.8118@ 77.2392) corner: ( 93.4259@ 6.373)
! !

!SimuroSotVideoServer class methodsFor: 'constants' stamp: 'Richo 6/21/2008 19:28'!
freeBall
	^ 1! !

!SimuroSotVideoServer class methodsFor: 'constants' stamp: 'Richo 6/21/2008 19:28'!
freeKick
	^ 4! !

!SimuroSotVideoServer class methodsFor: 'instance creation' stamp: 'Richo 7/14/2008 10:22'!
fromUser
	| port |
	port := (FillInTheBlank request: 'Port:' initialAnswer: self lastPort asString) asInteger.

	^ self port: port! !

!SimuroSotVideoServer class methodsFor: 'constants' stamp: 'Richo 4/1/2009 14:21'!
goalBounds
^ 2.8748 @ 49.6801 corner:  97.3632@ 33.932
! !

!SimuroSotVideoServer class methodsFor: 'constants' stamp: 'Richo 6/21/2008 19:28'!
goalKick
	^ 5! !

!SimuroSotVideoServer class methodsFor: 'instance creation' stamp: 'Richo 7/9/2008 22:47'!
lastPort
^lastPort ifNil: [6364]! !

!SimuroSotVideoServer class methodsFor: 'instance creation' stamp: 'Richo 11/3/2010 14:57'!
new
^self port: self lastPort ! !

!SimuroSotVideoServer class methodsFor: 'constants' stamp: 'Richo 6/21/2008 19:28'!
penaltyKick
	^ 3! !

!SimuroSotVideoServer class methodsFor: 'constants' stamp: 'Richo 6/21/2008 19:28'!
placeKick
	^ 2! !

!SimuroSotVideoServer class methodsFor: 'constants' stamp: 'Richo 6/21/2008 19:29'!
playersPerSide
	^ 5! !

!SimuroSotVideoServer class methodsFor: 'instance creation' stamp: 'Richo 7/9/2008 22:48'!
port: aSmallInteger 
lastPort := aSmallInteger.
	^ self basicNew
		setSocket: (Socket newUDP setPort: aSmallInteger)! !

!SimuroSotVideoServer class methodsFor: 'constants' stamp: 'Richo 6/21/2008 19:29'!
yellowBall
	^ 2! !

!SimuroSotVideoServer methodsFor: 'parsing' stamp: 'Richo 11/16/2010 11:50'!
createEnvironmentWithData: data
	| ball field homePlayers opponentPlayers |
	ball := MoveableObject position: ((data at: 1)
			at: 1) asNumber @ ((data at: 1)
				at: 2) asNumber founded: true.
	homePlayers := (1 to: 5) collect: [:i |
		MoveableObject position: ((data at: i + 1)
					at: 1) asNumber @ ((data at: i + 1)
						at: 2) asNumber rotation: (Angle degrees: ((data at: i + 1)
							at: 4) asNumber) founded: true].
	opponentPlayers := (1 to: 5) collect: [:i |
		MoveableObject position:  ((data at: i + 6)
					at: 1) asNumber @ ((data at: i + 6)
						at: 2) asNumber rotation: (Angle degrees: ((data at: i + 6)
							at: 4) asNumber) founded: true.
		].
	field := (Field fromRectangle: (self class fieldBounds)).
	^Environment field: field ball: ball homePlayers: homePlayers opponentPlayers: opponentPlayers! !

!SimuroSotVideoServer methodsFor: 'parsing' stamp: 'Richo 11/16/2010 11:51'!
currentEnvironment
	| data parser |
	data := self getData.
	parser := TextDiffBuilder new.
	^self createEnvironmentWithData: ((parser split: data by: Character lf)
				collect: [:each | parser split: each by: Character space]).! !

!SimuroSotVideoServer methodsFor: 'initialize-release' stamp: 'Richo 6/21/2008 18:58'!
disconnect
	socket closeAndDestroy! !

!SimuroSotVideoServer methodsFor: 'receiving' stamp: 'Richo 6/21/2008 18:43'!
getData
	| data |
	data := String new: 512.
	socket waitForData; receiveDataInto: data.
	^data! !

!SimuroSotVideoServer methodsFor: 'printing' stamp: 'Richo 7/12/2008 23:31'!
printOn: aStream 
	super printOn: aStream.
	aStream nextPutAll: '(' , socket port asString , ')'! !

!SimuroSotVideoServer methodsFor: 'private' stamp: 'Richo 6/21/2008 19:06'!
setSocket: aSocket 
socket := aSocket! !

!VideoServer class methodsFor: 'description for viewer' stamp: 'Richo 10/25/2010 15:34'!
descriptionForViewer
^self name! !

!VideoServer class methodsFor: 'instance creation' stamp: 'Richo 6/22/2008 17:42'!
fromUser
"Devuelve la conexin al servidor de video"
	^ self subclassResponsibility! !

!VideoServer methodsFor: 'abstract' stamp: 'Richo 11/16/2010 11:48'!
currentEnvironment
	self subclassResponsibility ! !

!VideoServer methodsFor: 'inverting field' stamp: 'Richo 10/25/2010 14:04'!
invertFieldOf: env
	self invertPositionOf: env currentBall in: env.
	self invertPositionOf: env previousBall in: env.
	env home
		do: [:r | 
			self invertPositionOf: r in: env.
			self invertRotationOf: r].
	env opponent
		do: [:r | 
			self invertPositionOf: r in: env.
			self invertRotationOf: r]! !

!VideoServer methodsFor: 'inverting field' stamp: 'Richo 10/26/2010 15:12'!
invertPositionOf: aRobotOrBall in: env

	aRobotOrBall position: env field left + (env field right - aRobotOrBall position x) @ (env field bottom + (env field top - aRobotOrBall position y))! !

!VideoServer methodsFor: 'inverting field' stamp: 'Richo 10/30/2009 17:32'!
invertRotationOf: aRobot
	"Suma 180 pero lo mantiene entre -180 y 180"
	aRobot rotation: aRobot rotation opposite! !

Object subclass: #ViewerPlugin
	instanceVariableNames: 'viewer isActive'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Viewer-Plugins'!

ViewerPlugin subclass: #AdvancedDebuggerPlugin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Viewer-Plugins'!

!AdvancedDebuggerPlugin class methodsFor: 'as yet unclassified' stamp: 'Richo 10/25/2010 15:28'!
priority
^ReplayPlugin priority - 0.05! !

!AdvancedDebuggerPlugin methodsFor: 'as yet unclassified' stamp: 'Richo 11/3/2010 17:14'!
debug
""
viewer currentEnv isNil ifTrue: [^self].
self halt.
viewer game strategy applyOn: viewer game team for: viewer currentEnv .
! !

!AdvancedDebuggerPlugin methodsFor: 'accessing' stamp: 'Richo 10/23/2009 16:36'!
menu
^ AlignmentMorph newRow color: Color transparent;
		 cornerStyle: #rounded;
		 borderWidth: 0;
		 layoutInset: 3;
		 vResizing: #shrinkWrap;
		 wrapCentering: #center;
		" addMorphBack: 'Advanced debugger: ' asString asMorph;"
		 addMorphBack: AlignmentMorph newVariableTransparentSpacer;
		addMorphBack: (SimpleButtonMorph new label: ' Debug strategy for current environment ... ';
				color: (Color red mixed: 0.3 with: Color blue muchLighter);
				 borderColor: #raised;
				cornerStyle: #rounded;
				 borderWidth: 2;
				 actionSelector: #debug;
				target: self);
				
			 addMorphBack: AlignmentMorph newVariableTransparentSpacer! !

ViewerPlugin subclass: #BallPredictorPlugin
	instanceVariableNames: 'ballPredictions predictor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Viewer-Plugins'!

!BallPredictorPlugin methodsFor: 'initializing' stamp: 'Richo 10/25/2010 15:25'!
initialize
super initialize.
predictor := BallPredictor new.! !

!BallPredictorPlugin methodsFor: 'as yet unclassified' stamp: 'Richo 10/26/2010 13:58'!
initializeBallPredictions
	| cant alpha |
	cant := 10.
	alpha := 1.
	ballPredictions := Array new: cant.
	1
		to: cant
		do: [:i | 
			ballPredictions
				at: i
				put: ((BallMorph new)
						color: (Color yellow alpha: alpha)).
			alpha := alpha - (alpha / (cant ))].
	ballPredictions
		do: [:each | viewer board addMorphBack: each]! !

!BallPredictorPlugin methodsFor: 'as yet unclassified' stamp: 'Richo 10/27/2009 14:46'!
menu
	| menu actButton |
	menu := AlignmentMorph newRow color: Color transparent;
		 cornerStyle: #rounded;
		 borderWidth: 0;
		 layoutInset: 3;
		 vResizing: #shrinkWrap;
		 wrapCentering: #center;
		 addMorphBack: self class asString asMorph;
		 addMorphBack: AlignmentMorph newVariableTransparentSpacer.
	actButton := SimpleButtonMorph new label: ' Activate ';
				color: (Color green mixed: 0.3 with: Color blue muchLighter);
				 borderColor: #raised;
				 borderWidth: 2.
	menu addMorphBack: (actButton actionSelector: #value;
			
			target: [self toggleActivateDeactivate.
				isActive
					ifTrue: [actButton color: (Color red mixed: 0.3 with: Color blue muchLighter);
							 label: ' Deactivate ']
					ifFalse: [actButton color: (Color green mixed: 0.3 with: Color blue muchLighter);
							 label: ' Activate ']]).
	^ menu! !

!BallPredictorPlugin methodsFor: 'as yet unclassified' stamp: 'Richo 10/27/2009 14:46'!
removeBallPredictions
	ballPredictions
		do: [:each | each delete]! !

!BallPredictorPlugin methodsFor: 'as yet unclassified' stamp: 'Richo 10/25/2010 14:10'!
step
	| currentEnv |
	currentEnv := viewer currentEnv previousEnvironment ifNil: [viewer currentEnv ].
	ballPredictions
		doWithIndex: [:ball :index | 
			viewer board setPosition: (predictor ballPositionAt: index on: currentEnv) of: ball in: currentEnv.]
! !

!BallPredictorPlugin methodsFor: 'as yet unclassified' stamp: 'Richo 10/27/2009 14:46'!
toggleActivateDeactivate
	super toggleActivateDeactivate.
	isActive
		ifTrue: [self initializeBallPredictions]
		ifFalse: [self removeBallPredictions]! !

ViewerPlugin subclass: #FoundedPlugin
	instanceVariableNames: 'ball'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Viewer-Plugins'!

!FoundedPlugin methodsFor: 'accessing' stamp: 'Richo 11/2/2009 14:43'!
menu
	| menu actButton |
	menu :=  AlignmentMorph newRow color: Color transparent;
		 cornerStyle: #rounded;
		 borderWidth: 0;
		 layoutInset: 3;
		 vResizing: #shrinkWrap;
		 wrapCentering: #center;
		 addMorphBack: self class asString asMorph;
		 addMorphBack: AlignmentMorph newVariableTransparentSpacer.

	actButton := SimpleButtonMorph new label: ' Activate ';
				color: (Color green mixed: 0.3 with: Color blue muchLighter);
				 borderColor: #raised;
				 borderWidth: 2.
	menu addMorphBack: (actButton actionSelector: #value;
			
			target: [self toggleActivateDeactivate.
				isActive
					ifTrue: [actButton color: (Color red mixed: 0.3 with: Color blue muchLighter);
							 label: ' Deactivate ']
					ifFalse: [actButton color: (Color green mixed: 0.3 with: Color blue muchLighter);
							 label: ' Activate ']]).
	^ menu! !

!FoundedPlugin methodsFor: 'stepping' stamp: 'Richo 11/3/2010 16:25'!
step
	| env homeMorphs morph opponentMorphs |
	env := viewer currentEnv.
	env ball founded
		ifTrue: [viewer board ball borderColor: Color green]
		ifFalse: [viewer board ball borderColor: Color red].
	homeMorphs := viewer board homeFor: env.
	1 to: homeMorphs size do: [:i|
		morph := homeMorphs at: i.
		(env homePlayers at: i) founded ifTrue: [morph borderColor: Color green] ifFalse: [morph borderColor: Color red]
		].
	opponentMorphs := viewer board opponentFor: env.
	1 to: opponentMorphs size do: [:i|
		morph := opponentMorphs at: i.
		(env opponentPlayers at: i) founded ifTrue: [morph borderColor: Color green] ifFalse: [morph borderColor: Color red]
		].
	! !

!FoundedPlugin methodsFor: 'activation' stamp: 'Richo 11/2/2009 15:36'!
toggleActivateDeactivate
	super toggleActivateDeactivate.
	isActive
		ifTrue: [
			(viewer board homeFor: viewer currentEnv) do: [:morph| morph borderWidth: 1] .
			(viewer board opponentFor: viewer currentEnv) do: [:morph| morph borderWidth: 1] .
			]
		ifFalse: [
			(viewer board homeFor: viewer currentEnv) do: [:morph| morph borderWidth: 0] .
			(viewer board opponentFor: viewer currentEnv) do: [:morph| morph borderWidth: 0] .
			viewer board ball borderColor: Color black]! !

ViewerPlugin subclass: #GCNowPlugin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Viewer-Plugins'!

!GCNowPlugin methodsFor: 'accessing' stamp: 'Richo 11/2/2009 15:41'!
menu
	^ AlignmentMorph newRow color: Color transparent;
		 cornerStyle: #rounded;
		 borderWidth: 0;
		 layoutInset: 3;
		 vResizing: #shrinkWrap;
		 wrapCentering: #center;
		 addMorphBack: AlignmentMorph newVariableTransparentSpacer;
		 addMorphBack: (SimpleButtonMorph new label: ' Smalltalk garbageCollect ';
			
			color: (Color yellow mixed: 0.3 with: Color blue muchLighter);
			 borderColor: #raised;
			 cornerStyle: #rounded;
			 borderWidth: 2;
			 actionSelector: #garbageCollect;
			 target: Smalltalk);
		 addMorphBack: AlignmentMorph newVariableTransparentSpacer"addMorphBack: 'Advanced debugger: ' asString asMorph;"! !

ViewerPlugin subclass: #ImagesHolderPlugin
	instanceVariableNames: 'blueImageList yellowImageList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Viewer-Plugins'!

!ImagesHolderPlugin class methodsFor: 'as yet unclassified' stamp: 'Richo 10/21/2009 14:27'!
priority
^0.6! !

!ImagesHolderPlugin methodsFor: 'accessing' stamp: 'Richo 10/13/2009 15:40'!
blueImageList

^blueImageList ifNil: [blueImageList := AlignmentMorph newRow color: Color transparent;
		 cornerStyle: #rounded;
		 borderWidth: 0;
		 layoutInset: 3;
		 vResizing: #shrinkWrap;
		 hResizing: #shrinkWrap;
		 wrapCentering: #center.]
	! !

!ImagesHolderPlugin methodsFor: 'initializing' stamp: 'Richo 10/13/2009 15:36'!
initialize
super initialize.
1 to: 5 do: [:i|
	self blueImageList addMorphBack: (SketchMorph withForm: (viewer imagesHolder blueImageAt: i)).
	self yellowImageList addMorphBack: (SketchMorph withForm: (viewer imagesHolder yellowImageAt: i))
	]! !

!ImagesHolderPlugin methodsFor: 'accessing' stamp: 'Richo 10/13/2009 15:41'!
menu
	| actButton menu |
menu := AlignmentMorph newRow color: Color transparent;
		 cornerStyle: #rounded;
		 borderWidth: 0;
		 layoutInset: 3;
		 vResizing: #shrinkWrap;
		 wrapCentering: #center; 
"		addMorphBack: 'Robot''s images: ' asMorph;"
		addMorphBack: AlignmentMorph newVariableTransparentSpacer;
		addMorphBack: self yellowImageList;
		addMorphBack: AlignmentMorph newVariableTransparentSpacer;
		addMorphBack: self blueImageList;
		addMorphBack: AlignmentMorph newVariableTransparentSpacer.
"	actButton := SimpleButtonMorph new label: ' Activate ';
				color: (Color green mixed: 0.3 with: Color blue muchLighter);
				 borderColor: #raised;
				 borderWidth: 2.
	menu addMorphBack: (actButton actionSelector: #value;
			
			target: [self toggleActivateDeactivate.
				isActive
					ifTrue: [actButton color: (Color red mixed: 0.3 with: Color blue muchLighter);
							 label: ' Deactivate ']
					ifFalse: [actButton color: (Color green mixed: 0.3 with: Color blue muchLighter);
							 label: ' Activate ']])."
	^ menu
! !

!ImagesHolderPlugin methodsFor: 'stepping' stamp: 'Richo 10/13/2009 15:34'!
step
! !

!ImagesHolderPlugin methodsFor: 'accessing' stamp: 'Richo 10/13/2009 15:40'!
yellowImageList

^yellowImageList ifNil: [yellowImageList := AlignmentMorph newRow color: Color transparent;
		 cornerStyle: #rounded;
		 borderWidth: 0;
		 layoutInset: 3;
		 vResizing: #shrinkWrap;
		 hResizing: #shrinkWrap;
		 wrapCentering: #center.]
	! !

ViewerPlugin subclass: #ReplayPlugin
	instanceVariableNames: 'currentEnvIndex isPlaying playButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Viewer-Plugins'!

!ReplayPlugin class methodsFor: 'as yet unclassified' stamp: 'Richo 10/21/2009 14:27'!
priority
^0.6! !

!ReplayPlugin methodsFor: 'actions' stamp: 'Richo 10/27/2009 17:35'!
activate 
isActive ifTrue: [^self].
isActive := true.
currentEnvIndex := 0.
viewer controlPanel pause.! !

!ReplayPlugin methodsFor: 'actions' stamp: 'Richo 10/21/2009 14:01'!
deactivate 
isActive := false.! !

!ReplayPlugin methodsFor: 'stepping' stamp: 'Richo 10/27/2009 17:33'!
decreaseIndex
	currentEnvIndex := currentEnvIndex - 1.
	currentEnvIndex < 0
		ifTrue: [currentEnvIndex := 0. isPlaying := false]! !

!ReplayPlugin methodsFor: 'accessing' stamp: 'Richo 10/25/2010 15:58'!
environmentsCount
| previous count |
previous := viewer game environment.
count := 0.
[previous isNil or: [previous previousEnvironment isNil]]
whileFalse: [previous := previous previousEnvironment. 
	count := count + 1].
^count! !

!ReplayPlugin methodsFor: 'actions' stamp: 'Richo 10/27/2009 17:31'!
goToFirst
self activate.
currentEnvIndex := self environmentsCount! !

!ReplayPlugin methodsFor: 'actions' stamp: 'Richo 10/27/2009 17:29'!
goToLast
self activate.
currentEnvIndex := 0! !

!ReplayPlugin methodsFor: 'actions' stamp: 'Richo 10/27/2009 17:36'!
goToNext
self activate.
currentEnvIndex := currentEnvIndex - 1 max: 0! !

!ReplayPlugin methodsFor: 'actions' stamp: 'Richo 10/27/2009 18:09'!
goToPrevious
self activate.
currentEnvIndex := currentEnvIndex + 1 min: self environmentsCount! !

!ReplayPlugin methodsFor: 'initializing' stamp: 'Richo 10/21/2009 14:21'!
initialize
super initialize.
currentEnvIndex := 1.
isPlaying := false.! !

!ReplayPlugin methodsFor: 'accessing' stamp: 'Richo 10/26/2009 14:34'!
menu
	| menu |
	menu := AlignmentMorph newRow color: Color transparent;
				 cornerStyle: #rounded;
				 borderWidth: 0;
				 layoutInset: 3;
				 vResizing: #shrinkWrap;
				 wrapCentering: #center;
				addMorphBack: AlignmentMorph newVariableTransparentSpacer ;

				 addMorphBack: (SimpleButtonMorph new label: ' << First ';
					
						
					color:   (Color blue  mixed: 0.2 with: Color orange muchLighter);
					 borderColor: #raised;
					cornerStyle: #rounded;
					 borderWidth: 2;
					 actionSelector: #goToFirst; 
					 target: self);
				 addMorphBack: (SimpleButtonMorph new label: ' < Previous ';
										
					color:   (Color blue  mixed: 0.2 with: Color orange muchLighter);
					 borderColor: #raised;
					cornerStyle: #rounded;
					 borderWidth: 2;
					 actionSelector: #goToPrevious;
					 actWhen: #whilePressed;
					 target: self).
		playButton := (SimpleButtonMorph new label: ' - Play from here - ';
						
					color:  (Color blue  mixed: 0.2 with: Color orange muchLighter);
					 borderColor: #raised;
					cornerStyle: #rounded;
					 borderWidth: 2).
				menu addMorphBack: (playButton
					 actionSelector: #play;
					 actWhen: #buttonUp;
					 target: self);
				 addMorphBack: (SimpleButtonMorph new label: ' Next > ';
						
					color:   (Color blue  mixed: 0.2 with: Color orange muchLighter);
					 borderColor: #raised;
					cornerStyle: #rounded;
					 borderWidth: 2;
					 actionSelector: #goToNext;
					 actWhen: #whilePressed;
					 target: self);
				 addMorphBack: (SimpleButtonMorph new label: ' Last >> ';
						
					color:   (Color blue  mixed: 0.2 with: Color orange muchLighter);
					 borderColor: #raised;
					cornerStyle: #rounded;
					 borderWidth: 2;
					 actionSelector: #goToLast;
					 target: self);
									addMorphBack: AlignmentMorph newVariableTransparentSpacer .
									^menu! !

!ReplayPlugin methodsFor: 'actions' stamp: 'Richo 10/23/2009 16:33'!
play
isPlaying := isPlaying not! !

!ReplayPlugin methodsFor: 'stepping' stamp: 'Richo 10/25/2010 13:45'!
step
viewer gameState = #run ifTrue: [^self deactivate].
viewer currentEnv: (viewer game environment previousEnvironment: currentEnvIndex).
isPlaying ifTrue: [self decreaseIndex.
						playButton label: ' - Stop - '; borderColor: (Color red mixed: 0.7 with: Color orange )]
						ifFalse: [playButton label: ' - Play from here - '; borderColor: #raised]
						! !

!ViewerPlugin class methodsFor: 'instance creation' stamp: 'Richo 10/13/2009 12:05'!
on: aRSViewerMorph
^(self basicNew setViewer: aRSViewerMorph ) initialize! !

!ViewerPlugin class methodsFor: 'constants' stamp: 'Richo 10/18/2009 17:24'!
priority
"Subclasses should change this value if they need to execute themselves in a specific order. Higher number means higher priority.

Range 0.0 ... 1.0"
^0.5! !

!ViewerPlugin methodsFor: 'initializing' stamp: 'Richo 10/13/2009 12:06'!
initialize
isActive := false! !

!ViewerPlugin methodsFor: 'initializing' stamp: 'Richo 10/13/2009 12:07'!
menu
	"Debe devolver un menu para activar/desactivar el plugin"
	self subclassResponsibility! !

!ViewerPlugin methodsFor: 'private' stamp: 'Richo 10/13/2009 12:06'!
setViewer: aRSViewerMorph
	viewer := aRSViewerMorph ! !

!ViewerPlugin methodsFor: 'stepping' stamp: 'Richo 10/13/2009 12:06'!
step
self subclassResponsibility! !

!ViewerPlugin methodsFor: 'stepping' stamp: 'Richo 10/13/2009 12:06'!
stepIfActive
	isActive ifTrue: [self step]! !

!ViewerPlugin methodsFor: 'activation' stamp: 'Richo 10/20/2009 12:42'!
toggleActivateDeactivate
	isActive := isActive not.! !

Morph subclass: #BoardMorph
	instanceVariableNames: 'ball home opponent imagesHolder gameState'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Viewer'!

BoardMorph class
	instanceVariableNames: 'form'!

BoardMorph class
	instanceVariableNames: 'form'!

!BoardMorph class methodsFor: 'form' stamp: 'Richo 10/9/2009 15:57'!
form
	^ form
		ifNil: [self initializeForm]! !

!BoardMorph class methodsFor: 'form' stamp: 'Richo 10/9/2009 15:58'!
initializeForm
^form := (Form
	extent: 675@500
	depth: 1
	fromArray: #( 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294966784 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4194303 4294967295 4294967295 3758096384 4294967295 4294967295 4294966272 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1048575 4294967295 4294967295 3758096384 4294967295 4294967295 4294965375 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278714367 4294967295 4294967295 3758096384 4294967295 4294967295 4294963455 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4286840831 4294967295 4294967295 3758096384 4294967295 4294967295 4294959615 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4290904063 4294967295 4294967295 3758096384 4294967295 4294967295 4294951935 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4292935679 4294967295 4294967295 3758096384 4294967295 4294967295 4294936575 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293951487 4294967295 4294967295 3758096384 4294967295 4294967295 4294905855 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294459391 4294967295 4294967295 3758096384 4294967295 4294967295 4294844415 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294713343 4294967295 4294967295 3758096384 4294967295 4294967295 4294721535 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294840319 4294967295 4294967295 3758096384 4294967295 4294967295 4294475775 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294903807 4294967295 4294967295 3758096384 4294967295 4294967295 4293984255 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294935551 4294967295 4294967295 3758096384 4294967295 4294967295 4293001215 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294951423 4294967295 4294967295 3758096384 4294967295 4294967295 4291035135 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294959359 4294967295 4294967295 3758096384 4294967295 4294967295 4287102975 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294963327 4294967295 4294967295 3758096384 4294967295 4294967295 4279238655 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294965311 4294967295 4294967295 3758096384 4294967295 4294967295 4263510015 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294966303 4294967295 4294967295 3758096384 4294967295 4294967295 4232052735 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294966799 4294967295 4294967295 3758096384 4294967295 4294967295 4169138175 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967047 4294967295 4294967295 3758096384 4294967295 4294967295 4043309055 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967171 4294967295 4294967295 3758096384 4294967295 4294967295 3791650815 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967233 4294967295 4294967295 3758096384 4294967295 4294967295 3288334335 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967264 4294967295 4294967295 3758096384 4294967295 4294967295 2281701375 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967280 2147483647 4294967295 3758096384 4294967295 4294967295 268435455 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967288 1073741823 4294967295 3758096384 4294967295 4294967294 536870911 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967292 536870911 4294967295 3758096384 4294967295 4294967292 1073741823 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967294 268435455 4294967295 3758096384 4294967295 4294967288 2147483647 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 134217727 4294967295 3758096384 4294967295 4294967288 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 2281701375 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4282384383 4294967295 4294967295 4294967295 4194303999 4294967295 4294918143 4294967295 4294967271 4294967295 4294967295 4294967295 4294967103 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4282384383 4294967295 4294967295 4294967295 4194303999 4294967295 4294918143 4294967295 4294967271 4294967295 4294967295 4294967295 4294967103 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4282384383 4294967295 4169138175 4294967295 4194303999 4294967295 4294918143 4294967295 4294967271 4294967295 4294967055 4294967295 4294967103 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4282384383 4294967295 4030726143 4294967295 4194303999 4294967295 4294918143 4294967295 4294967271 4294967295 4294966791 4294967295 4294967103 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4282384383 4294967295 3886022655 4294967295 4194303999 4294967295 4294918143 4294967295 4294967271 4294967295 4294966515 4294967295 4294967103 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4282384383 4294967295 3886022655 4294967295 4194303999 4294967295 4294918143 4294967295 4294967271 4294967295 4294966515 4294967295 4294967103 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4282384383 4294967295 3886022655 4294967295 4194303999 4294967295 4294918143 4294967295 4294967271 4294967295 4294966515 4294967295 4294967103 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4282384383 4294967295 3886022655 4294967295 4194303999 4294967295 4294918143 4294967295 4294967271 4294967295 4294966515 4294967295 4294967103 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4282384383 4294967295 4030726143 4294967295 4194303999 4294967295 4294918143 4294967295 4294967271 4294967295 4294966791 4294967295 4294967103 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4282384383 4294967295 4169138175 4294967295 4194303999 4294967295 4294918143 4294967295 4294967271 4294967295 4294967055 4294967295 4294967103 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4282384383 4294967295 4294967295 4294967295 4194303999 4294967295 4294918143 4294967295 4294967271 4294967295 4294967295 4294967295 4294967103 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4282384383 4294967295 4294967295 4294967295 4194303999 4294967295 4294918143 4294967295 4294967271 4294967295 4294967295 4294967295 4294967103 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967288 0 0 1023 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4292870144 0 0 134217727 4294967295 3758096384 4294967295 4294967288 0 0 1023 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4292870144 0 0 134217727 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967288 0 268435455 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967288 0 134217727 4294967295 3758096384 4294967295 4294967288 0 268435455 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4278190207 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967288 0 134217727 4294967295 3758096384 4294967295 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 3221225473 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4294967292 16727936 536870911 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4294967264 1073692670 67108863 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4294967043 4294918143 3766484991 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4294966303 4294918143 4229955583 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4294963327 4294918143 4278714367 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4294951935 4294918143 4293001215 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4294905855 4294918143 4294475775 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4294852607 4294918143 4294852607 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4294475775 4294918143 4294905855 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4294049791 4294918143 4294952959 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4294967295 3758096384 4294966784 1 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4291035135 4294918143 4294959615 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3758096384 4194303 3758096384 4294966784 1 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4287627263 4294918143 4294965503 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3758096384 4194303 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4280287231 4294918143 4294966399 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4232052735 4294918143 4294966815 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4177526783 4294918143 4294967183 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4060086271 4294918143 4294967239 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 3825205247 4294918143 4294967267 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 3355443199 4294918143 4294967281 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 2415919103 4294918143 4294967288 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 2684354559 4294918143 4294967292 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 1073741823 4294918143 4294967294 2147483647 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967294 1073741823 4294918143 4294967294 1073741823 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967292 2147483647 4294918143 4294967295 536870911 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967292 4294967295 4294918143 4294967295 2684354559 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967289 4294967295 4294918143 4294967295 3489660927 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967281 4294967295 4294918143 4294967295 3355443199 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967283 4294967295 4294918143 4294967295 3892314111 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967271 4294967295 4294918143 4294967295 4093640703 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967239 4294967295 4294918143 4294967295 4060086271 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967247 4294967295 4294918143 4294967295 4194303999 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967199 4294967295 4294918143 4294967295 4244635647 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967199 4294967295 4294918143 4294967295 4244635647 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967103 4294967295 4294918143 4294967295 4269801471 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967103 4294967295 4294918143 4294967295 4269801471 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294966911 4294967295 4294918143 4294967295 4282384383 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294966911 4294967295 4294918143 4294967295 4282384383 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294966399 4294967295 4294918143 4294967295 4280287231 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294966527 4294967295 4294918143 4294967295 4288675839 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294966527 4294967295 4294918143 4294967295 4288675839 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294965759 4294967295 4294918143 4294967295 4291821567 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294965759 4294967295 4294918143 4294967295 4291821567 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294965759 4294967295 4294918143 4294967295 4291821567 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294964223 4294967295 4294918143 4294967295 4293394431 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294964223 4294967295 4294918143 4294967295 4293394431 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294964223 4294967295 4294918143 4294967295 4293394431 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294964223 4294967295 4294918143 4294967295 4293394431 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294961151 4294967295 4294918143 4294967295 4294180863 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294961151 4294967295 4294918143 4294967295 4294180863 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294961151 4294967295 4294918143 4294967295 4294180863 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294961151 4294967295 4294918143 4294967295 4294180863 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294961151 4294967295 4294918143 4294967295 4294180863 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294961151 4294967295 4294918143 4294967295 4294180863 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294955007 4294967295 4294918143 4294967295 4294574079 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294955007 4294967295 4294918143 4294967295 4294574079 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294955007 4294967295 4294918143 4294967295 4294574079 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294955007 4294967295 4294918143 4294967295 4294574079 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294955007 4294967295 4294918143 4294967295 4294574079 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964103 4294967295 4294967295 4294967295 4294955007 4294967295 4294918143 4294967295 4294574079 4294967295 4294967295 4294967295 4041736191 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294963971 4294967295 4294967295 4294967295 4294955007 4294967295 4294918143 4294967295 4294574079 4294967295 4294967295 4294967295 3764912127 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294963833 4294967295 4294967295 4294967295 4294955007 4294967295 4294918143 4294967295 4294574079 4294967295 4294967295 4294967295 3475505151 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294963833 4294967295 4294967295 4294967295 4294955007 4294967295 4294918143 4294967295 4294574079 4294967295 4294967295 4294967295 3475505151 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294963833 4294967295 4294967295 4294967295 4294955007 4294967295 4294918143 4294967295 4294574079 4294967295 4294967295 4294967295 3475505151 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294963833 4294967295 4294967295 4294967295 4294955007 4294967295 4294918143 4294967295 4294574079 4294967295 4294967295 4294967295 3475505151 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294963971 4294967295 4294967295 4294967295 4294955007 4294967295 4294918143 4294967295 4294574079 4294967295 4294967295 4294967295 3764912127 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964103 4294967295 4294967295 4294967295 4294955007 4294967295 4294918143 4294967295 4294574079 4294967295 4294967295 4294967295 4041736191 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294955007 4294967295 4294918143 4294967295 4294574079 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294955007 4294967295 4294918143 4294967295 4294574079 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294955007 4294967295 4294918143 4294967295 4294574079 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294955007 4294967295 4294918143 4294967295 4294574079 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294961151 4294967295 4294918143 4294967295 4294705151 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294961151 4294967295 4294918143 4294967295 4294705151 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294961151 4294967295 4294918143 4294967295 4294180863 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294961151 4294967295 4294918143 4294967295 4294180863 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294961151 4294967295 4294918143 4294967295 4294180863 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294961151 4294967295 4294918143 4294967295 4294180863 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294964223 4294967295 4294918143 4294967295 4293394431 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294964223 4294967295 4294918143 4294967295 4293394431 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294964223 4294967295 4294918143 4294967295 4293394431 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294964223 4294967295 4294918143 4294967295 4293394431 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294965759 4294967295 4294918143 4294967295 4291821567 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294965759 4294967295 4294918143 4294967295 4291821567 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294965759 4294967295 4294918143 4294967295 4291821567 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294966527 4294967295 4294918143 4294967295 4288675839 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294966527 4294967295 4294918143 4294967295 4288675839 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294966399 4294967295 4294918143 4294967295 4280287231 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294966911 4294967295 4294918143 4294967295 4282384383 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294966911 4294967295 4294918143 4294967295 4282384383 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967103 4294967295 4294918143 4294967295 4269801471 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967103 4294967295 4294918143 4294967295 4269801471 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967199 4294967295 4294918143 4294967295 4244635647 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967199 4294967295 4294918143 4294967295 4244635647 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967247 4294967295 4294918143 4294967295 4194303999 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967239 4294967295 4294918143 4294967295 4060086271 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967271 4294967295 4294918143 4294967295 4093640703 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967283 4294967295 4294918143 4294967295 3892314111 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967281 4294967295 4294918143 4294967295 3355443199 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967289 4294967295 4294918143 4294967295 3489660927 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967292 4294967295 4294918143 4294967295 2684354559 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967292 2147483647 4294918143 4294967295 536870911 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967294 1073741823 4294918143 4294967294 1073741823 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 1073741823 4294918143 4294967294 2147483647 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 2684354559 4294918143 4294967292 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 2415919103 4294918143 4294967288 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 3355443199 4294918143 4294967281 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 3825205247 4294918143 4294967267 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4060086271 4294918143 4294967239 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4177526783 4294918143 4294967183 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4232052735 4294918143 4294966815 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4280287231 4294918143 4294966399 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4287627263 4294918143 4294965503 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966784 1 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4291035135 4294918143 4294959615 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3758096384 4194303 3758096384 4294966784 1 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4294049791 4294918143 4294952959 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3758096384 4194303 3758096384 4294967295 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4294475775 4294918143 4294905855 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4294852607 4294918143 4294852607 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4294905855 4294918143 4294475775 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4294951935 4294918143 4293001215 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4294963327 4294918143 4278714367 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4294966303 4294918143 4229955583 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4294967043 4294918143 3766484991 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4294967264 1073692670 67108863 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4294967292 16727936 536870911 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 3221225473 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4294967295 3758096384 4294967295 4294967288 0 268435455 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4278190207 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967288 0 134217727 4294967295 3758096384 4294967295 4294967288 0 268435455 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967288 0 134217727 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967288 0 0 1023 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4292870144 0 0 134217727 4294967295 3758096384 4294967295 4294967288 0 0 1023 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4292870144 0 0 134217727 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4282384383 4294967295 4294967295 4294967295 4194303999 4294967295 4294918143 4294967295 4294967271 4294967295 4294967295 4294967295 4294967103 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4282384383 4294967295 4294967295 4294967295 4194303999 4294967295 4294918143 4294967295 4294967271 4294967295 4294967295 4294967295 4294967103 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4282384383 4294967295 4169138175 4294967295 4194303999 4294967295 4294918143 4294967295 4294967271 4294967295 4294967055 4294967295 4294967103 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4282384383 4294967295 4030726143 4294967295 4194303999 4294967295 4294918143 4294967295 4294967271 4294967295 4294966791 4294967295 4294967103 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4282384383 4294967295 3886022655 4294967295 4194303999 4294967295 4294918143 4294967295 4294967271 4294967295 4294966515 4294967295 4294967103 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4282384383 4294967295 3886022655 4294967295 4194303999 4294967295 4294918143 4294967295 4294967271 4294967295 4294966515 4294967295 4294967103 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4282384383 4294967295 3886022655 4294967295 4194303999 4294967295 4294918143 4294967295 4294967271 4294967295 4294966515 4294967295 4294967103 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4282384383 4294967295 3886022655 4294967295 4194303999 4294967295 4294918143 4294967295 4294967271 4294967295 4294966515 4294967295 4294967103 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4282384383 4294967295 4030726143 4294967295 4194303999 4294967295 4294918143 4294967295 4294967271 4294967295 4294966791 4294967295 4294967103 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4282384383 4294967295 4169138175 4294967295 4194303999 4294967295 4294918143 4294967295 4294967271 4294967295 4294967055 4294967295 4294967103 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4282384383 4294967295 4294967295 4294967295 4194303999 4294967295 4294918143 4294967295 4294967271 4294967295 4294967295 4294967295 4294967103 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4282384383 4294967295 4294967295 4294967295 4194303999 4294967295 4294918143 4294967295 4294967271 4294967295 4294967295 4294967295 4294967103 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3355443199 4294967295 3758096384 4294967295 4294967288 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 2281701375 4294967295 3758096384 4294967295 4294967292 2147483647 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 268435455 4294967295 3758096384 4294967295 4294967294 1073741823 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967294 536870911 4294967295 3758096384 4294967295 4294967295 536870911 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967292 1073741823 4294967295 3758096384 4294967295 4294967295 2415919103 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967288 2147483647 4294967295 3758096384 4294967295 4294967295 3355443199 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967280 4294967295 4294967295 3758096384 4294967295 4294967295 3825205247 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967265 4294967295 4294967295 3758096384 4294967295 4294967295 4060086271 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967235 4294967295 4294967295 3758096384 4294967295 4294967295 4177526783 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967175 4294967295 4294967295 3758096384 4294967295 4294967295 4236247039 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967055 4294967295 4294967295 3758096384 4294967295 4294967295 4265607167 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294966815 4294967295 4294967295 3758096384 4294967295 4294967295 4280287231 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294966335 4294967295 4294967295 3758096384 4294967295 4294967295 4287627263 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294965375 4294967295 4294967295 3758096384 4294967295 4294967295 4291297279 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294963455 4294967295 4294967295 3758096384 4294967295 4294967295 4293132287 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294959615 4294967295 4294967295 3758096384 4294967295 4294967295 4294049791 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294951935 4294967295 4294967295 3758096384 4294967295 4294967295 4294508543 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294936575 4294967295 4294967295 3758096384 4294967295 4294967295 4294737919 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294905855 4294967295 4294967295 3758096384 4294967295 4294967295 4294852607 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294844415 4294967295 4294967295 3758096384 4294967295 4294967295 4294909951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294721535 4294967295 4294967295 3758096384 4294967295 4294967295 4294938623 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294475775 4294967295 4294967295 3758096384 4294967295 4294967295 4294952959 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293984255 4294967295 4294967295 3758096384 4294967295 4294967295 4294960127 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293001215 4294967295 4294967295 3758096384 4294967295 4294967295 4294963711 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4291035135 4294967295 4294967295 3758096384 4294967295 4294967295 4294965503 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4287102975 4294967295 4294967295 3758096384 4294967295 4294967295 4294966399 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4279238655 4294967295 4294967295 3758096384 4294967295 4294967295 4294966847 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4263510015 4294967295 4294967295 3758096384 4294967295 4294967295 4294966784 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4194303 4294967295 4294967295 3758096384 4294967295 4294967295 4294967040 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 8388607 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384)
	offset: 0@0)! !

!BoardMorph class methodsFor: 'conversion' stamp: 'Richo 10/9/2009 17:35'!
squeakAngle: robotSoccerAngle 
| angN dif |
angN := 90 - robotSoccerAngle.
angN>180 ifTrue:[
	dif := angN - 180.
	angN := -180 + dif.
	
	].
^angN! !

!BoardMorph methodsFor: 'accessing' stamp: 'Richo 10/25/2010 15:29'!
ball
	ball
		isNil ifTrue: [self addMorph: (ball := BallMorph new)].
	^ ball! !

!BoardMorph methodsFor: 'drawing environment' stamp: 'Richo 11/3/2010 16:19'!
draw: env 
"I draw the environment and refresh the event handling to inspect the current objects"
	| i r |
	self
		setPosition: env ball position 
		of: (self ball
				on: #mouseDown
				send: #inspect
				to: env ball)
		in: env.
	i := 1.
	(self homeFor: env)
		do: [:each | 
			r := env homePlayers at: i.
			self
				setPosition: r position 
				of: each
				in: env.
			each
				heading: (self class squeakAngle: r rotation degrees);
				
				on: #mouseDown
				send: #inspect
				to: r.
			i := i + 1].
	i := 1.
	(self opponentFor: env)
		do: [:each | 
			r := env opponentPlayers at: i.
			self
				setPosition: r position 
				of: each
				in: env.
			each
				heading: (self class squeakAngle: r rotation degrees);
				
				on: #mouseDown
				send: #inspect
				to: r.
			i := i + 1]! !

!BoardMorph methodsFor: 'drawing' stamp: 'Richo 10/9/2009 16:00'!
drawOn: aCanvas
	aCanvas drawImage: self class form at: self topLeft! !

!BoardMorph methodsFor: 'accessing' stamp: 'Richo 10/9/2009 16:53'!
fieldBounds
^self bounds topLeft + (61@24) corner: (self bounds topLeft + (612@475))! !

!BoardMorph methodsFor: 'game state' stamp: 'Richo 10/23/2009 18:08'!
gameState: aSymbol
"aSymbol may be one of the following:
#stop
#pause
#run"
| newContents newColor |
newContents := ''.
newColor := Color transparent.
aSymbol = #stop ifTrue: [newContents := 'Stopped'. newColor := Color red].
aSymbol = #pause ifTrue: [newContents := 'Paused'. newColor := Color yellow].
aSymbol = #run ifTrue: [newContents := 'Running...'. newColor := Color green].
gameState contents = newContents ifFalse: [gameState contents: newContents].
gameState color = newColor ifFalse: [gameState color: newColor].! !

!BoardMorph methodsFor: 'accessing' stamp: 'Richo 11/3/2010 16:20'!
homeFor: env 
	"Arreglar eso para luego poder elegir las imgenes de cada robot"

	home isNil
		ifTrue: [home := (1 to: env homePlayers size)
								collect: [:i | RobotMorph
										withForm: (imagesHolder blueImageAt: i)].
			home
				do: [:r | self addMorph: r]]
			ifFalse: [
				env homePlayers size = home size
				ifFalse: [home do: [:m | m delete]. 
					home := nil.
					^self homeFor: env].
				]
			.
	^ home! !

!BoardMorph methodsFor: 'accessing' stamp: 'Richo 10/13/2009 15:23'!
imagesHolder
^imagesHolder! !

!BoardMorph methodsFor: 'initialize' stamp: 'Richo 10/25/2010 15:29'!
initialize
	super initialize.
	self
		extent: (self class form extent);
		 cornerStyle: #rounded.
	imagesHolder := ImagesHolder new.
	gameState := '' asString asMorph font: Preferences windowTitleFont;
		 color: Color red.
	self addMorph: (gameState topLeft: self topLeft + (5@2)).! !

!BoardMorph methodsFor: 'accessing' stamp: 'Richo 11/3/2010 16:20'!
opponentFor: env 
	"Arreglar eso para luego poder elegir las imgenes de cada robot"
	opponent isNil
		ifTrue: [opponent := (1 to: env opponentPlayers size)
								collect: [:i | RobotMorph
										withForm: (imagesHolder yellowImageAt: i)].
			opponent
				do: [:r | self addMorph: r]]
			ifFalse: [env homePlayers size = opponent size
				ifFalse: [opponent
						do: [:m | m delete].
					opponent := nil.
					^ self opponentFor: env]].
	^ opponent! !

!BoardMorph methodsFor: 'drawing environment' stamp: 'Richo 10/26/2010 14:56'!
setPosition: aPoint of: aMorph in: anEnvironment 
	| differenceWithCenter pixelDifference newCenter |
	differenceWithCenter := aPoint - anEnvironment field center.
	differenceWithCenter := differenceWithCenter x @ (differenceWithCenter y * -1).
	pixelDifference := differenceWithCenter * self fieldBounds width / anEnvironment field width.
	newCenter :=  self fieldBounds center + pixelDifference.
	(self bounds containsPoint: newCenter)
		ifTrue: [	aMorph center: newCenter]
		ifFalse: [aMorph center: (self bounds pointNearestTo: newCenter)]! !

Morph subclass: #RobotMorph
	instanceVariableNames: 'form'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Viewer'!

!RobotMorph class methodsFor: 'instance creation' stamp: 'Richo 10/9/2009 18:00'!
new
self shouldNotImplement.
! !

!RobotMorph class methodsFor: 'instance creation' stamp: 'Richo 10/13/2009 10:35'!
withForm: aForm
^(self basicNew setForm: aForm) initialize! !

!RobotMorph methodsFor: 'accessing' stamp: 'Richo 10/13/2009 12:33'!
center
(self owner isMemberOf: TransformationMorph)
ifTrue:[^self owner center].
^super center
! !

!RobotMorph methodsFor: 'accessing' stamp: 'Richo 10/13/2009 12:33'!
center: aPoint 
"Para mantener las coordenadas correctas si el robot gira"
	(self owner isMemberOf: TransformationMorph)
		ifTrue: [^ self owner center: aPoint].
	^ super center: aPoint! !

!RobotMorph methodsFor: 'drawing' stamp: 'Richo 11/2/2009 15:30'!
drawOn: aCanvas
aCanvas translucentImage: form at: self bounds topLeft.
aCanvas frameRectangle: self bounds width: self borderWidth color: self borderColor! !

!RobotMorph methodsFor: 'initialize' stamp: 'Richo 11/2/2009 15:30'!
initialize
super initialize.
self extent: form extent! !

!RobotMorph methodsFor: 'private' stamp: 'Richo 10/13/2009 10:34'!
setForm: aForm
form := aForm! !

AlignmentMorph subclass: #ControlPanelMorph
	instanceVariableNames: 'game robotServerLabel videoServerLabel teamLabel strategyLabel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Viewer'!

!ControlPanelMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 10/26/2009 17:43'!
on: aGame
^(self basicNew setGame: aGame) initialize! !

!ControlPanelMorph methodsFor: 'robot server' stamp: 'Richo 10/25/2010 16:03'!
chooseRobotServerClass
	| choice robotServers strRobotServers |
	robotServers := RobotServer allSubclasses asArray sort: [:a :b | a descriptionForViewer < b descriptionForViewer].
	strRobotServers := robotServers
				collect: [:each | '  ' , each descriptionForViewer , '  '].
	choice := PopUpMenu withCaption: 'RobotServers:' chooseFrom: strRobotServers.
	choice = 0
		ifTrue: [^ nil].
	^robotServers at: choice! !

!ControlPanelMorph methodsFor: 'as yet unclassified' stamp: 'Richo 11/3/2010 16:12'!
chooseStrategyClass
	| strOptions choice strategies |
	strategies := Strategy allSubclasses asArray sort: [:a :b | a descriptionForViewer < b descriptionForViewer].
	strOptions := strategies
				collect: [:each | '  ' , each descriptionForViewer , '  '].
	choice := PopUpMenu withCaption: 'Strategy:' chooseFrom: strOptions.
	choice = 0
		ifTrue: [^ nil].
	^ strategies at: choice! !

!ControlPanelMorph methodsFor: 'team' stamp: 'Richo 10/25/2010 15:43'!
chooseTeamClass
	| teams strTeams choice |
	teams := Team allSubclasses asArray sort: [:a :b | a descriptionForViewer < b descriptionForViewer].
	strTeams := teams
				collect: [:each | '  ' , each descriptionForViewer , '  '].
	choice := PopUpMenu withCaption: 'Teams:' chooseFrom: strTeams.
	choice = 0
		ifTrue: [^ nil].
	^ teams at: choice! !

!ControlPanelMorph methodsFor: 'video server' stamp: 'Richo 10/25/2010 16:03'!
chooseVideoServerClass
	| choice videoServers strVideoServers |
	videoServers := VideoServer allSubclasses asArray sort: [:a :b | a descriptionForViewer < b descriptionForViewer].
	strVideoServers := videoServers
				collect: [:each | '  ' , each descriptionForViewer , '  '].
	choice := PopUpMenu withCaption: 'VideoServers:' chooseFrom: strVideoServers.
	choice = 0
		ifTrue: [^ nil].
	^videoServers at: choice! !

!ControlPanelMorph methodsFor: 'initialize-release' stamp: 'Richo 10/26/2009 16:59'!
initialize
super initialize.
self listDirection: #leftToRight;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		extent: 1@1;
		borderWidth: 0;
		color: Color transparent.
self initializeSubmorphs! !

!ControlPanelMorph methodsFor: 'initialize-release' stamp: 'Richo 10/26/2009 17:06'!
initializeSubmorphs
self addMorphBack: self makeConnectionPanel;
		 addMorphBack: self makeControlPanel! !

!ControlPanelMorph methodsFor: 'building' stamp: 'Richo 11/3/2010 16:08'!
makeConnectionPanel
	^ AlignmentMorph newColumn color: Color transparent;
		 addMorphBack: self makeStrategyControlPanel;
		 addMorphBack: self makeVideoServerControlPanel;
		 addMorphBack: self makeRobotServerControlPanel
! !

!ControlPanelMorph methodsFor: 'building' stamp: 'Richo 10/26/2009 16:59'!
makeControlPanel
	^ AlignmentMorph newColumn color: Color transparent;
		 addMorphBack: self makeStartPauseStopPanel;
		 addMorphBack: AlignmentMorph newVariableTransparentSpacer! !

!ControlPanelMorph methodsFor: 'building' stamp: 'Richo 10/26/2009 23:53'!
makeRobotServerControlPanel
	robotServerLabel := game robotServer asString asMorph.
	^ AlignmentMorph newRow color: Color transparent;
		 addMorphBack: (SimpleButtonMorph new label: '  RobotServer ...  ';
			
			color: (Color blue mixed: 0.3 with: Color blue muchLighter);
			 borderColor: #raised;
			 borderWidth: 2;
			 actionSelector: #setRobotServer;
			 target: self);
		 addMorphBack: (SimpleButtonMorph new label: '  Remove  ';
			
			color: (Color red mixed: 0.3 with: Color blue muchLighter);
			 borderColor: #raised;
			 borderWidth: 2;
			 actionSelector: #removeRobotServer;
			 target: self);
		 addMorphBack: ' --> ' asMorph;
		 addMorphBack: robotServerLabel;
		 addMorphBack: AlignmentMorph newVariableTransparentSpacer! !

!ControlPanelMorph methodsFor: 'building' stamp: 'Richo 10/26/2009 17:00'!
makeStartPauseStopPanel
	^ AlignmentMorph newRow color: Color transparent;
		 cornerStyle: #rounded;
		 borderWidth: 0;
		 layoutInset: 3;
		 vResizing: #shrinkWrap;
		 wrapCentering: #center;
				 addMorphBack: AlignmentMorph newVariableTransparentSpacer ;
		 addMorphBack: (SimpleButtonMorph new label: '  Start  ';
			
			color: (Color green mixed: 0.3 with: Color blue muchLighter);
			 borderColor: #raised;
			 borderWidth: 2;
			 actionSelector: #start;
			 target: self);
		 addMorphBack: (SimpleButtonMorph new label: '  Pause  ';
			
			color: (Color blue mixed: 0.3 with: Color blue muchLighter);
			 borderColor: #raised;
			 borderWidth: 2;
			 actionSelector: #pause;
			 target: self);
		 addMorphBack: (SimpleButtonMorph new label: '  Stop  ';
			
			color: (Color red mixed: 0.3 with: Color blue muchLighter);
			 borderColor: #raised;
			 borderWidth: 2;
			 actionSelector: #stop;
			 target: self)! !

!ControlPanelMorph methodsFor: 'as yet unclassified' stamp: 'Richo 11/3/2010 16:09'!
makeStrategyControlPanel
	strategyLabel := game strategy asString asMorph.
	^ AlignmentMorph newRow color: Color transparent;
		 addMorphBack: (SimpleButtonMorph new label: '  Strategy ...  ';
			
			color: (Color blue mixed: 0.3 with: Color blue muchLighter);
			 borderColor: #raised;
			 borderWidth: 2;
			 actionSelector: #setStrategy;
			 target: self);
		 addMorphBack: (SimpleButtonMorph new label: '  Remove  ';
			
			color: (Color red mixed: 0.3 with: Color blue muchLighter);
			 borderColor: #raised;
			 borderWidth: 2;
			 actionSelector: #removeStrategy;
			 target: self);
		 addMorphBack: ' --> ' asMorph;
		 addMorphBack: strategyLabel;
		 addMorphBack: AlignmentMorph newVariableTransparentSpacer! !

!ControlPanelMorph methodsFor: 'building' stamp: 'Richo 10/26/2009 23:53'!
makeVideoServerControlPanel
	videoServerLabel := game videoServer asString asMorph.
	^ AlignmentMorph newRow color: Color transparent;
		 addMorphBack: (SimpleButtonMorph new label: '  VideoServer ...  ';
			
			color: (Color blue mixed: 0.3 with: Color blue muchLighter);
			 borderColor: #raised;
			 borderWidth: 2;
			 actionSelector: #setVideoServer;
			 target: self);
		 addMorphBack: (SimpleButtonMorph new label: '  Remove  ';
			
			color: (Color red mixed: 0.3 with: Color blue muchLighter);
			 borderColor: #raised;
			 borderWidth: 2;
			 actionSelector: #removeVideoServer;
			 target: self);
		 addMorphBack: ' --> ' asMorph;
		 addMorphBack: videoServerLabel;
		 addMorphBack: AlignmentMorph newVariableTransparentSpacer! !

!ControlPanelMorph methodsFor: 'start/pause/stop' stamp: 'Richo 10/26/2009 17:44'!
pause
game pause.! !

!ControlPanelMorph methodsFor: 'initialize-release' stamp: 'Richo 10/26/2009 23:50'!
removeAll
game removeAll.
self updateLabels! !

!ControlPanelMorph methodsFor: 'robot server' stamp: 'Richo 10/26/2009 23:51'!
removeRobotServer
game removeRobotServer .
self updateLabels! !

!ControlPanelMorph methodsFor: 'as yet unclassified' stamp: 'Richo 11/3/2010 17:52'!
removeStrategy
game removeStrategy.
self updateLabels! !

!ControlPanelMorph methodsFor: 'video server' stamp: 'Richo 10/26/2009 23:51'!
removeVideoServer
game removeVideoServer .
self updateLabels! !

!ControlPanelMorph methodsFor: 'private' stamp: 'Richo 10/26/2009 17:43'!
setGame: aGame
game := aGame! !

!ControlPanelMorph methodsFor: 'robot server' stamp: 'Richo 10/26/2009 23:53'!
setRobotServer
	| robotServerClass |
	robotServerClass := self chooseRobotServerClass.
	robotServerClass
		ifNotNil: [game robotServer: robotServerClass fromUser].
	self updateLabels! !

!ControlPanelMorph methodsFor: 'as yet unclassified' stamp: 'Richo 11/3/2010 16:11'!
setStrategy
	| strategyClass |
	strategyClass := self chooseStrategyClass.
	strategyClass
		ifNotNil: [game strategy: strategyClass fromUser].
	self updateLabels! !

!ControlPanelMorph methodsFor: 'team' stamp: 'Richo 10/30/2009 17:57'!
setTeam
	| teamClass |
	teamClass := self chooseTeamClass.
	teamClass
		ifNotNil: [game team: teamClass fromUser].
	self updateLabels! !

!ControlPanelMorph methodsFor: 'video server' stamp: 'Richo 10/26/2009 23:53'!
setVideoServer
	| videoServerClass |
	videoServerClass := self chooseVideoServerClass.
	videoServerClass
		ifNotNil: [game videoServer: videoServerClass fromUser].
	self updateLabels! !

!ControlPanelMorph methodsFor: 'start/pause/stop' stamp: 'Richo 10/26/2009 17:44'!
start	
	[game start] on: Error do: [:err| ^self inform: err description].
! !

!ControlPanelMorph methodsFor: 'stepping' stamp: 'Richo 10/26/2009 23:43'!
step
self updateLabels! !

!ControlPanelMorph methodsFor: 'stepping' stamp: 'Richo 10/26/2009 23:43'!
stepTime
^1000! !

!ControlPanelMorph methodsFor: 'start/pause/stop' stamp: 'Richo 10/30/2009 15:56'!
stop
	game stop.
	"self removeAll."
	"viewer
		submorphsDo: [:m | m delete].
	viewer initializeSubmorphs"! !

!ControlPanelMorph methodsFor: 'updating' stamp: 'Richo 11/3/2010 16:10'!
updateLabels
	robotServerLabel contents = game robotServer asString
		ifFalse: [robotServerLabel contents: game robotServer asString]. 
	videoServerLabel contents = game videoServer asString
		ifFalse: [videoServerLabel contents: game videoServer asString].
	strategyLabel contents = game strategy asString
		ifFalse: [strategyLabel contents: game strategy asString]! !

AlignmentMorph subclass: #DoraemonMorph
	instanceVariableNames: 'videoServer portText fieldBoundsText goalBoundsText connectionButton isYellowTeam'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Servers-Real-Doraemon'!

DoraemonMorph class
	instanceVariableNames: 'videoServer'!

DoraemonMorph class
	instanceVariableNames: 'videoServer'!

!DoraemonMorph class methodsFor: 'instance creation' stamp: 'Richo 10/25/2010 15:47'!
new
^self videoServer: DoraemonVideoServer new! !

!DoraemonMorph class methodsFor: 'instance creation' stamp: 'Richo 10/27/2009 00:03'!
videoServer: aVideoServer
^(self basicNew setVideoServer: aVideoServer) initialize! !

!DoraemonMorph methodsFor: 'connection' stamp: 'Richo 10/26/2010 15:04'!
connect
	videoServer fieldBounds: self fieldBounds;
		 goalBounds: self goalBounds;
		 isYellowTeam: isYellowTeam;
		 connectOnPort: self port ! !

!DoraemonMorph methodsFor: 'initialize-release' stamp: 'Richo 10/26/2009 23:45'!
delete
self disconnect.
super delete.! !

!DoraemonMorph methodsFor: 'connection' stamp: 'Richo 10/26/2009 23:45'!
disconnect
videoServer disconnect.
! !

!DoraemonMorph methodsFor: 'accessing' stamp: 'Richo 10/26/2009 16:16'!
fieldBounds
^Compiler evaluate: fieldBoundsText contents asString! !

!DoraemonMorph methodsFor: 'accessing' stamp: 'Richo 10/26/2009 16:16'!
goalBounds
^Compiler evaluate: goalBoundsText contents asString! !

!DoraemonMorph methodsFor: 'initialize-release' stamp: 'Richo 10/30/2009 17:11'!
initialize
	super initialize.
	self borderWidth: 2;
		
		color: ((Color
				r: 0.817
				g: 0.864
				b: 0.797)
				mixed: 0.75
				with: Color blue muchDarker);
		 borderColor: #raised;
		 hResizing: #shrinkWrap;
		 vResizing: #shrinkWrap;
		 listDirection: #topToBottom;
		 cornerStyle: #rounded.
	isYellowTeam := false.
	self initializeSubmorphs! !

!DoraemonMorph methodsFor: 'initialize-release' stamp: 'Richo 10/30/2009 17:09'!
initializeSubmorphs
self addMorphBack: self makeTitle;
	addMorphBack: self makePortPanel;
	addMorphBack: self makeFieldBoundsPanel;
	addMorphBack: self makeGoalBoundsPanel;
	addMorphBack: self makeIsYellowTeamPanel;
	addMorphBack: self makeConnectionPanel.! !

!DoraemonMorph methodsFor: 'connection' stamp: 'Richo 10/26/2009 16:28'!
isConnected
^videoServer isConnected! !

!DoraemonMorph methodsFor: 'accessing' stamp: 'Richo 10/30/2009 17:11'!
isYellowTeam
^isYellowTeam! !

!DoraemonMorph methodsFor: 'building' stamp: 'Richo 10/27/2009 12:29'!
makeConnectionPanel
	connectionButton := SimpleButtonMorph new label: ' Connect ';
				
				color: (Color green mixed: 0.3 with: Color blue muchLighter);
				 borderColor: #raised; 
				 borderWidth: 2.
	^ AlignmentMorph newRow color: Color transparent;
		 cornerStyle: #rounded;
		 borderWidth: 0;
		 layoutInset: 3;
		 vResizing: #shrinkWrap;
		 wrapCentering: #center;
		 addMorphBack: AlignmentMorph newVariableTransparentSpacer;
		 addMorphBack: (connectionButton actionSelector: #value;
			
			target: [self isConnected
					ifTrue: [self disconnect]
					ifFalse: [self connect].
					self updateConnectionButton.
					])! !

!DoraemonMorph methodsFor: 'building' stamp: 'Richo 10/26/2009 16:35'!
makeFieldBoundsPanel
fieldBoundsText := self newTextMorph contents: videoServer class lastFieldBounds storeString.
	^ AlignmentMorph newRow color: Color transparent;
		 cornerStyle: #rounded;
		 borderWidth: 0;
		 layoutInset: 3;
		 vResizing: #shrinkWrap;
		 wrapCentering: #center;
		 addMorphBack: ('Field bounds: ' asMorph);
		 addMorphBack: AlignmentMorph newVariableTransparentSpacer;
		 addMorphBack: (fieldBoundsText)! !

!DoraemonMorph methodsFor: 'building' stamp: 'Richo 10/26/2009 16:36'!
makeGoalBoundsPanel
goalBoundsText :=  self newTextMorph  contents: videoServer class lastGoalBounds storeString.
	^ AlignmentMorph newRow color: Color transparent;
		 cornerStyle: #rounded;
		 borderWidth: 0;
		 layoutInset: 3;
		 vResizing: #shrinkWrap;
		 wrapCentering: #center;
		 addMorphBack: ('Goal bounds: ' asMorph);
		 addMorphBack: AlignmentMorph newVariableTransparentSpacer;
		 addMorphBack: (goalBoundsText)! !

!DoraemonMorph methodsFor: 'building' stamp: 'Richo 10/30/2009 17:17'!
makeIsYellowTeamPanel
^Morph new extent: 0 @ 25;
				 cellInset: 10;
				 color: Color transparent;
				 layoutPolicy: TableLayout new;
				 listDirection: #leftToRight;
				listCentering: #center;
				 wrapCentering: #center;
				 hResizing: #spaceFill;
				 vResizing: #rigid;
				 addMorphBack: (UpdatingThreePhaseButtonMorph checkBox target: self;
					 actionSelector: #toggleIsYellowTeam;
					 getSelector: #isYellowTeam;
					 yourself);
				addMorphBack: 'is yellow team' asMorph! !

!DoraemonMorph methodsFor: 'building' stamp: 'Richo 10/26/2009 16:36'!
makePortPanel
portText := self newTextMorph contents: videoServer class lastPort asString.
	^ AlignmentMorph newRow color: Color transparent;
		 cornerStyle: #rounded;
		 borderWidth: 0;
		 layoutInset: 3;
		 vResizing: #shrinkWrap;
		 wrapCentering: #center;
		 addMorphBack: ('Port: ' asMorph);
		 addMorphBack: AlignmentMorph newVariableTransparentSpacer;
		 addMorphBack: (portText)! !

!DoraemonMorph methodsFor: 'building' stamp: 'Richo 10/30/2009 17:47'!
makeTitle
	^ AlignmentMorph newRow color: Color transparent;
		 cornerStyle: #rounded;
		 borderWidth: 0;
		 layoutInset: 3;
		 vResizing: #shrinkWrap;
		 wrapCentering: #center;
		 addMorphBack: (self asString asMorph font: Preferences windowTitleFont);
		 addMorphBack: AlignmentMorph newVariableTransparentSpacer";
		 addMorphBack: (SimpleButtonMorph new label: '  X  ';
			
			color: (Color red mixed: 0.3 with: Color blue muchLighter);
			 borderColor: #raised;
			 borderWidth: 2;
			 actionSelector: #delete;
			 target: self)"! !

!DoraemonMorph methodsFor: 'building' stamp: 'Richo 10/26/2009 16:02'!
newTextMorph
^TextMorph new autoFit: false;
extent: 250@23; borderWidth: 1;backgroundColor: Color white.! !

!DoraemonMorph methodsFor: 'accessing' stamp: 'Richo 10/26/2009 16:15'!
port
^portText contents asString asNumber! !

!DoraemonMorph methodsFor: 'private' stamp: 'Richo 10/27/2009 00:03'!
setVideoServer: aVideoServer
videoServer := aVideoServer! !

!DoraemonMorph methodsFor: 'stepping' stamp: 'Richo 10/27/2009 12:28'!
step
self updateConnectionButton.! !

!DoraemonMorph methodsFor: 'stepping' stamp: 'Richo 10/27/2009 12:28'!
stepTime
^1000
! !

!DoraemonMorph methodsFor: 'as yet unclassified' stamp: 'Richo 10/30/2009 17:11'!
toggleIsYellowTeam
isYellowTeam := isYellowTeam not! !

!DoraemonMorph methodsFor: 'updating' stamp: 'Richo 10/27/2009 14:22'!
updateConnectionButton
self isConnected
					ifFalse: [
						connectionButton label: ' Connect ';
							
							color: (Color green mixed: 0.3 with: Color blue muchLighter)]
					ifTrue: [
						connectionButton label: ' Disconnect ';
							
							color: (Color red mixed: 0.3 with: Color blue muchLighter)]! !

!DoraemonMorph methodsFor: 'accessing' stamp: 'Richo 9/29/2009 17:20'!
videoServer
	^ videoServer! !

AlignmentMorph subclass: #LegoNxtMorph
	instanceVariableNames: 'robotServer numberOfRobots legoPortsTexts connectionButtons'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Servers-Real-LegoNxt'!

!LegoNxtMorph class methodsFor: 'instance creation' stamp: 'Richo 10/28/2009 15:40'!
on: robotServer 
^(self basicNew setRobotServer: robotServer) initialize! !

!LegoNxtMorph methodsFor: 'actions' stamp: 'Richo 10/30/2009 15:08'!
changeNumberOfRobots
	| n |
	n := (FillInTheBlank request: 'Number of robots:' initialAnswer: numberOfRobots asString) asInteger.
	self numberOfRobots: n.
	self submorphsDo: [:m| m delete].
	self initializeSubmorphs.! !

!LegoNxtMorph methodsFor: 'connection' stamp: 'Richo 10/30/2009 15:37'!
connectAll
1 to: numberOfRobots do: [:i| self connectAt: i]! !

!LegoNxtMorph methodsFor: 'connection' stamp: 'Richo 10/30/2009 15:13'!
connectAt: nRobot
robotServer connectRobotAt: nRobot on: (self legoPorts at: nRobot)
! !

!LegoNxtMorph methodsFor: 'initialize-release' stamp: 'Richo 10/30/2009 15:15'!
delete
self disconnectAll.
super delete.! !

!LegoNxtMorph methodsFor: 'connection' stamp: 'Richo 10/30/2009 15:37'!
disconnectAll
1 to: numberOfRobots do: [:i| self disconnectAt: i]! !

!LegoNxtMorph methodsFor: 'connection' stamp: 'Richo 10/30/2009 15:15'!
disconnectAt: nRobot
robotServer disconnectAt: nRobot! !

!LegoNxtMorph methodsFor: 'initialize-release' stamp: 'Richo 10/30/2009 15:05'!
initialize
	super initialize.
	self borderWidth: 2;
		
		color: ((Color
				r: 0.817
				g: 0.864
				b: 0.797)
				mixed: 0.75
				with: Color blue muchDarker);
		 borderColor: #raised;
		 hResizing: #shrinkWrap;
		 vResizing: #shrinkWrap;
		 listDirection: #topToBottom;
		 cornerStyle: #rounded.
	self numberOfRobots: 3.
	self initializeSubmorphs! !

!LegoNxtMorph methodsFor: 'initialize-release' stamp: 'Richo 10/30/2009 15:32'!
initializeSubmorphs
self addMorphBack: self makeTitle;
	addMorphBack: self makeNRobotsPanel.
1 to: numberOfRobots do: [:i|
	self addMorphBack: (self makeLegoConnectionPanelFor: i)
	].
self addMorphBack: self makeAllConnectionPanel! !

!LegoNxtMorph methodsFor: 'connection' stamp: 'Richo 10/30/2009 15:15'!
isConnectedAt: nRobot
^robotServer isConnectedAt: nRobot! !

!LegoNxtMorph methodsFor: 'accessing' stamp: 'Richo 10/30/2009 15:14'!
legoPorts
^legoPortsTexts collect: [:each| each contents asNumber]! !

!LegoNxtMorph methodsFor: 'building' stamp: 'Richo 10/30/2009 17:52'!
makeAllConnectionPanel
	^ AlignmentMorph newRow color: Color transparent;
		 cornerStyle: #rounded;
		 borderWidth: 0;
		 layoutInset: 3;
		 vResizing: #shrinkWrap;
		 wrapCentering: #center;
		addMorphBack: AlignmentMorph newVariableTransparentSpacer ;
		 addMorphBack: (SimpleButtonMorph new label: ' Connect all ';
				
				color: (Color green mixed: 0.3 with: Color blue muchLighter);
				 borderColor: #raised; 
				 borderWidth: 2;
				actionSelector: #value;
			
			target: [self connectAll.
					self updateConnectionButtons.
					]
				);
		addMorphBack: ' ' asMorph;
		addMorphBack: (SimpleButtonMorph new label: ' Disconnect all ';
				
				color: (Color red mixed: 0.3 with: Color blue muchLighter);
				 borderColor: #raised; 
				 borderWidth: 2;
				actionSelector: #value;
			
			target: [self disconnectAll.
					self updateConnectionButtons.
					]
				);
		addMorphBack: AlignmentMorph newVariableTransparentSpacer ! !

!LegoNxtMorph methodsFor: 'building' stamp: 'Richo 10/28/2009 15:46'!
makeFieldBoundsPanel
| fieldBoundsText |
fieldBoundsText := self newTextMorph contents: '6'.
	^ AlignmentMorph newRow color: Color transparent;
		 cornerStyle: #rounded;
		 borderWidth: 0;
		 layoutInset: 3;
		 vResizing: #shrinkWrap;
		 wrapCentering: #center;
		 addMorphBack: ('Robot 1 port: ' asMorph);
		 addMorphBack: AlignmentMorph newVariableTransparentSpacer;
		 addMorphBack: (fieldBoundsText)! !

!LegoNxtMorph methodsFor: 'building' stamp: 'Richo 10/30/2009 15:10'!
makeLegoConnectionPanelFor: nRobot
	legoPortsTexts at: nRobot put: (self newTextMorph contents: (5 + nRobot) asString).
	connectionButtons at: nRobot put: (SimpleButtonMorph new label: ' Connect ';
				
				color: (Color green mixed: 0.3 with: Color blue muchLighter);
				 borderColor: #raised; 
				 borderWidth: 2).
	^ AlignmentMorph newRow color: Color transparent;
		 cornerStyle: #rounded;
		 borderWidth: 0;
		 layoutInset: 3;
		 vResizing: #shrinkWrap;
		 wrapCentering: #center;
		 addMorphBack: (('Lego #', nRobot asString, ': ') asMorph);
		 addMorphBack: AlignmentMorph newVariableTransparentSpacer;
		 addMorphBack: (legoPortsTexts at: nRobot);
		 addMorphBack: ('  ' asMorph);
		 addMorphBack: ((connectionButtons at: nRobot) actionSelector: #value;
			
			target: [(self isConnectedAt: nRobot)
					ifTrue: [self disconnectAt: nRobot]
					ifFalse: [self connectAt: nRobot].
					self updateConnectionButtons.
					])! !

!LegoNxtMorph methodsFor: 'building' stamp: 'Richo 10/30/2009 15:21'!
makeNRobotsPanel
	| nRobotsText |
	nRobotsText := numberOfRobots asString asMorph emphasis: 2.
	^ AlignmentMorph newRow color: Color transparent;
		 cornerStyle: #rounded;
		 borderWidth: 0;
		 layoutInset: 3;
		 vResizing: #shrinkWrap;
		 wrapCentering: #center;
		 addMorphBack: 'Number of robots: ' asMorph;
		 addMorphBack: nRobotsText;
		 addMorphBack: ' ' asMorph;
		 addMorphBack: (SimpleButtonMorph new label: ' ... ';
			 color: self color;
			 borderColor: #raised;
			 borderWidth: 2;
			 actionSelector: #changeNumberOfRobots;
			 target: self)! !

!LegoNxtMorph methodsFor: 'building' stamp: 'Richo 10/30/2009 17:51'!
makeTitle
	^ AlignmentMorph newRow color: Color transparent;
		 cornerStyle: #rounded;
		 borderWidth: 0;
		 layoutInset: 3;
		 vResizing: #shrinkWrap;
		 wrapCentering: #center;
		 addMorphBack: (self asString asMorph font: Preferences windowTitleFont);
		 addMorphBack: AlignmentMorph newVariableTransparentSpacer";
		 addMorphBack: (SimpleButtonMorph new label: '  X  ';
			
			color: (Color red mixed: 0.3 with: Color blue muchLighter);
			 borderColor: #raised;
			 borderWidth: 2;
			 actionSelector: #delete;
			 target: self)"! !

!LegoNxtMorph methodsFor: 'building' stamp: 'Richo 10/30/2009 15:32'!
newTextMorph
^TextMorph new autoFit: false;
extent: 50@23; borderWidth: 1; backgroundColor: Color white.! !

!LegoNxtMorph methodsFor: 'accessing' stamp: 'Richo 10/30/2009 15:05'!
numberOfRobots: aNumber
	numberOfRobots := aNumber.
	connectionButtons := Array new: numberOfRobots.
	legoPortsTexts := Array new: numberOfRobots.! !

!LegoNxtMorph methodsFor: 'accessing' stamp: 'Richo 10/30/2009 17:53'!
robotServer
^robotServer ! !

!LegoNxtMorph methodsFor: 'private' stamp: 'Richo 10/28/2009 15:40'!
setRobotServer: aRSLegoNxtRobotServer 
robotServer := aRSLegoNxtRobotServer ! !

!LegoNxtMorph methodsFor: 'stepping' stamp: 'Richo 10/30/2009 15:20'!
step
self updateConnectionButtons ! !

!LegoNxtMorph methodsFor: 'stepping' stamp: 'Richo 10/30/2009 15:20'!
stepTime
^1000! !

!LegoNxtMorph methodsFor: 'updating' stamp: 'Richo 10/30/2009 15:12'!
updateConnectionButtons
1 to: numberOfRobots do: [:i|
	(self isConnectedAt: i)
	ifTrue: [
		(connectionButtons at: i) label: ' Disconnect ';							
							color: (Color red mixed: 0.3 with: Color blue muchLighter)
		]
	ifFalse: [
		(connectionButtons at: i) label: ' Connect ';							
							color: (Color green mixed: 0.3 with: Color blue muchLighter)
		]
	]
! !

AlignmentMorph subclass: #ViewerMorph
	instanceVariableNames: 'board game plugins currentEnv controlPanel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Viewer'!

!ViewerMorph class methodsFor: 'parts bin' stamp: 'Richo 10/13/2009 12:22'!
descriptionForPartsBin
	^ self
		partName: 'Robot Soccer Viewer'
		categories: #('Robot Soccer' )
		documentation: ''! !

!ViewerMorph methodsFor: 'initialize-release' stamp: 'Richo 10/25/2010 15:28'!
addPluginList

	plugins := (ViewerPlugin allSubclasses asArray sort: [:a :b | a priority >= b priority])
				collect: [:each | each on: self].
	plugins
				do: [:each | self addMorphBack: each menu].! !

!ViewerMorph methodsFor: 'accessing' stamp: 'Richo 10/13/2009 12:08'!
board
^board! !

!ViewerMorph methodsFor: 'accessing' stamp: 'Richo 10/26/2009 17:21'!
controlPanel
^controlPanel! !

!ViewerMorph methodsFor: 'accessing' stamp: 'Richo 10/18/2009 17:25'!
currentEnv
^currentEnv ! !

!ViewerMorph methodsFor: 'accessing' stamp: 'Richo 10/18/2009 17:25'!
currentEnv: anEnvironment
currentEnv  := anEnvironment! !

!ViewerMorph methodsFor: 'initialize-release' stamp: 'Richo 10/26/2009 23:50'!
delete
	controlPanel removeAll.
	super delete! !

!ViewerMorph methodsFor: 'accessing' stamp: 'Richo 10/13/2009 12:08'!
game
^game! !

!ViewerMorph methodsFor: 'accessing' stamp: 'Richo 10/21/2009 13:48'!
gameState
	game isPaused ifTrue: [^#pause].
	game isStopped ifTrue: [^#stop].
	^#run! !

!ViewerMorph methodsFor: 'accessing' stamp: 'Richo 10/13/2009 15:24'!
imagesHolder
^board imagesHolder! !

!ViewerMorph methodsFor: 'initialize-release' stamp: 'Richo 10/25/2010 15:25'!
initialize
	super initialize.
	self borderWidth: 2;
	color: ((Color
		r: 0.817
		g: 0.864
		b: 0.797)
		mixed: 0.75
		with: Color blue muchDarker);
		 borderColor: #raised;
		 hResizing: #shrinkWrap;
		 vResizing: #shrinkWrap;
		 listDirection: #topToBottom;
		 cornerStyle: #rounded.
	game := Game new.
	self initializeSubmorphs.
! !

!ViewerMorph methodsFor: 'initialize-release' stamp: 'Richo 10/25/2010 15:29'!
initializeSubmorphs
	board := BoardMorph new.
	controlPanel := ControlPanelMorph on: game.
	self addMorphBack: self makeTitle;
		 addMorphBack: controlPanel;
		 addMorphBack: board.
	
	self addPluginList! !

!ViewerMorph methodsFor: 'initialize-release' stamp: 'Richo 10/26/2009 17:04'!
makeTitle
	^ AlignmentMorph newRow color: Color transparent;
		 cornerStyle: #rounded;
		 borderWidth: 0;
		 layoutInset: 3;
		 vResizing: #shrinkWrap;
		 wrapCentering: #center;
		 addMorphBack: ('Robot Soccer Viewer' asMorph font: Preferences windowTitleFont);
		 addMorphBack: AlignmentMorph newVariableTransparentSpacer;
		 addMorphBack: (SimpleButtonMorph new label: '  X  ';
			
			color: (Color red mixed: 0.3 with: Color blue muchLighter);
			 borderColor: #raised;
			 borderWidth: 2;
			 actionSelector: #delete;
			 target: self)! !

!ViewerMorph methodsFor: 'stepping' stamp: 'Richo 11/3/2010 16:18'!
step
	board
		 gameState: (self gameState).
	currentEnv := game environment.
	currentEnv isNil
		ifTrue: [^ self].
	plugins
		do: [:each | each stepIfActive]. 
	board
		 draw: currentEnv! !

!ViewerMorph methodsFor: 'stepping' stamp: 'Richo 11/3/2010 16:21'!
stepTime
^100! !

!TextDiffBuilder methodsFor: '*RobotSoccer' stamp: 'Richo 10/22/2010 15:27'!
split: aString by: splitChar
	| lines index nextIndex |
	lines := OrderedCollection new.
	index := 1.
	[index <= aString size] whileTrue:[
		nextIndex := aString 
						indexOf: splitChar 
						startingAt: index 
						ifAbsent:[aString size+1].
		lines add: (aString copyFrom: index to: nextIndex-1).
		index := nextIndex+1].
	^lines! !

TestCase subclass: #AngleTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Tests'!

!AngleTest methodsFor: 'igual' stamp: 'Richo 10/25/2010 15:22'!
testIgual1
	| a1 a2 |
	a1 := Angle degrees: 45.
	a2 := Angle degrees: 45.
	self
		should: [a1 = a2].
	self
		shouldnt: [a1
				= (Angle degrees: 46)]! !

!AngleTest methodsFor: 'igual' stamp: 'Richo 10/25/2010 15:22'!
testIgual2
	| a1 a2 |
	a1 := Angle degrees: 45.
	a2 := Angle radians: 0.785398163397448.
	self
		should: [a1 = a2].
	self
		shouldnt: [a1
				= (Angle radians: 1)]! !

!AngleTest methodsFor: 'igual' stamp: 'Richo 10/25/2010 15:23'!
testIgual3
	| a1 a2 |
	a1 := Angle radians: 0.785398163397448.
	a2 := Angle degrees: 45.
	self
		should: [a1 = a2]! !

!AngleTest methodsFor: 'igual' stamp: 'Richo 10/25/2010 15:22'!
testIgual4
	| a1 a2 |
	a1 := Angle radians: 0.785398163397448.
	a2 := Angle radians: 0.78539817.
	self
		should: [a1 = a2]! !

!AngleTest methodsFor: 'igual' stamp: 'Richo 10/25/2010 15:22'!
testIgual5
	| a1 a2 |
	a1 := Angle degrees: 45.005.
	a2 := Angle degrees: 45.004.
	self
		should: [a1 = a2]! !

!AngleTest methodsFor: 'inicializacion' stamp: 'Richo 10/25/2010 15:22'!
testInicializacionGrados
	| a |
	a := Angle degrees: 45.
	self
		should: [a degrees = 45].
	self
		should: [a radians closeTo: 0.785398163397448].
! !

!AngleTest methodsFor: 'inicializacion' stamp: 'Richo 10/25/2010 15:23'!
testInicializacionGrados2
	| a |
	a := Angle degrees: -45.
	self
		should: [a degrees = -45].
	self
		should: [a radians closeTo: -0.785398163397448].
! !

!AngleTest methodsFor: 'inicializacion' stamp: 'Richo 10/25/2010 15:22'!
testInicializacionRadianes
	| a |
	a := Angle radians: 0.785398163397448.
	self
		should: [a degrees closeTo: 45].
	self
		should: [a radians closeTo: 0.785398163397448].
! !

!AngleTest methodsFor: 'inicializacion' stamp: 'Richo 10/25/2010 15:22'!
testInicializacionRadianes2
	| a |
	a := Angle radians: -0.785398163397448.
	self
		should: [a degrees closeTo: -45].
	self
		should: [a radians closeTo: -0.785398163397448].
! !

!AngleTest methodsFor: 'negated' stamp: 'Richo 10/25/2010 15:22'!
testNegated
	| a |
	a := Angle degrees: 45.
	self
		should: [a negated degrees closeTo: -45].
	self
		should: [a negated radians closeTo: -0.785398163397448]! !

!AngleTest methodsFor: 'negated' stamp: 'Richo 10/25/2010 15:22'!
testNegated2
	| a |
	a := Angle degrees: 180.
	self
		should: [a negated degrees closeTo: -180].
	self
		should: [a negated radians closeTo: -3.141592653589793]! !

!AngleTest methodsFor: 'opuesto' stamp: 'Richo 10/25/2010 15:22'!
testOpuesto
	| a |
	a := Angle degrees: 90.
	self
		should: [a opposite
				= (Angle degrees: -90)].
	self
		shouldnt: [a opposite
				= (Angle degrees: -91)]! !

!AngleTest methodsFor: 'opuesto' stamp: 'Richo 10/25/2010 15:22'!
testOpuesto2
	| a |
	a := Angle degrees: 45.
	self
		should: [a opposite
				= (Angle degrees: -135)].
	self
		shouldnt: [a opposite
				= (Angle degrees: -91)]! !

!AngleTest methodsFor: 'opuesto' stamp: 'Richo 10/25/2010 15:22'!
testOpuesto3
	| a |
	a := Angle degrees: 15.
	self
		should: [a opposite
				= (Angle degrees: -165)].
	self
		shouldnt: [a opposite
				= (Angle degrees: -91)]! !

!AngleTest methodsFor: 'opuesto' stamp: 'Richo 10/25/2010 15:22'!
testOpuesto4
	| a |
	a := Angle degrees: 0.
	self
		should: [a opposite
				= (Angle degrees: 180)].
	self
		shouldnt: [a opposite
				= (Angle degrees: -91)]! !

!AngleTest methodsFor: 'resta' stamp: 'Richo 10/25/2010 15:22'!
testResta1
	| a1 a2 |
	a1 := Angle degrees: 179.
	a2 := Angle degrees: -2.
	self
		should: [(a1 - a2) degrees = -179]! !

!AngleTest methodsFor: 'resta' stamp: 'Richo 10/25/2010 15:22'!
testResta2
	| a1 a2 |
	a1 := Angle degrees: 135.
	a2 := Angle degrees: -180.
	self
		should: [(a1 - a2) degrees = -45]! !

!AngleTest methodsFor: 'resta' stamp: 'Richo 10/25/2010 15:22'!
testResta3
	| a1 a2 |
	a1 := Angle degrees: -135.
	a2 := Angle degrees: -180.
	self
		should: [(a1 - a2) degrees = 45]! !

!AngleTest methodsFor: 'resta' stamp: 'Richo 10/25/2010 15:23'!
testResta4
	| a1 a2 |
	a1 := Angle degrees: -30.
	a2 := Angle degrees: 10.
	self
		should: [(a1 - a2) degrees = -40]! !

!AngleTest methodsFor: 'resta' stamp: 'Richo 10/25/2010 15:22'!
testResta5
	| a1 a2 |
	a1 := Angle degrees: 10.
	a2 := Angle degrees: -30.
	self
		should: [(a1 - a2) degrees = 40]! !

!AngleTest methodsFor: 'resta' stamp: 'Richo 10/25/2010 15:23'!
testResta6
	| a1 a2 |
	a1 := Angle degrees: -10.
	a2 := Angle degrees: 30.
	self
		should: [(a1 - a2) degrees = -40]! !

!AngleTest methodsFor: 'resta' stamp: 'Richo 10/25/2010 15:23'!
testResta7
	| a1 a2 |
	a1 := Angle degrees: -45.
	a2 := Angle degrees: 0.
	self
		should: [(a1 - a2) degrees = -45]! !

!AngleTest methodsFor: 'suma' stamp: 'Richo 10/25/2010 15:22'!
testSuma1
	| a1 a2 |
	a1 := Angle degrees: 45.
	a2 := Angle degrees: 90.
	self
		should: [(a1 + a2) degrees = 135]! !

!AngleTest methodsFor: 'suma' stamp: 'Richo 10/25/2010 15:22'!
testSuma2
	| a1 a2 |
	a1 := Angle degrees: 135.
	a2 := Angle degrees: 90.
	self
		should: [(a1 + a2) degrees = -135]! !

!AngleTest methodsFor: 'suma' stamp: 'Richo 10/25/2010 15:22'!
testSuma3
	| a1 a2 |
	a1 := Angle degrees: 45.
	a2 := Angle degrees: 180.
	self
		should: [(a1 + a2) degrees = -135]! !

!AngleTest methodsFor: 'suma' stamp: 'Richo 10/25/2010 15:23'!
testSuma4
	| a1 a2 |
	a1 := Angle degrees: -45.
	a2 := Angle degrees: 180.
	self
		should: [(a1 + a2) degrees = 135]! !

!AngleTest methodsFor: 'suma' stamp: 'Richo 10/25/2010 15:23'!
testSuma5
	| a1 a2 |
	a1 := Angle degrees: -45.
	a2 := Angle degrees: -180.
	self
		should: [(a1 + a2) degrees = 135]! !

!AngleTest methodsFor: 'suma' stamp: 'Richo 10/25/2010 15:22'!
testSuma6
	| a1 a2 |
	a1 := Angle degrees: -179.
	a2 := Angle degrees: -2.
	self
		should: [(a1 + a2) degrees = 179]! !

!AngleTest methodsFor: 'suma' stamp: 'Richo 10/25/2010 15:22'!
testSuma7
	| a1 a2 |
	a1 := Angle degrees: 0.
	a2 := Angle degrees: 45.
	self
		should: [(a1 + a2) degrees = 45]! !

TestCase subclass: #EnvironmentTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Tests'!

!EnvironmentTest methodsFor: 'as yet unclassified' stamp: 'Richo 10/25/2010 15:26'!
testShouldDecideTeam
	| env home opponent currentBall  |
	env := Environment new.
	home := Array new: 5.
	opponent := Array new: 5.
	1
		to: 5
		do: [:i | 
			home
				at: i
				put: (Robot new environment: env).
			opponent at: i put: OpponentRobot new].
	currentBall := Ball new.
	env home: home;
		 opponent: opponent;
		 currentBall: currentBall! !

TestCase subclass: #RobotExampleTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Tests'!

!RobotExampleTest methodsFor: 'calcularAngulo' stamp: 'Richo 10/25/2010 15:30'!
testCalcularAngulo
	| robot ang |
	robot := RobotExample new.
	ang := robot getAngle: 10 @ 10.
	self
		should: [ang degrees closeTo: 45]! !

!RobotExampleTest methodsFor: 'calcularAngulo' stamp: 'Richo 10/25/2010 15:31'!
testCalcularAngulo2
	| robot ang |
	robot := RobotExample new.
	ang := robot getAngle: 10 @ 0.
	self
		should: [ang degrees closeTo: 0]! !

!RobotExampleTest methodsFor: 'calcularAngulo' stamp: 'Richo 10/25/2010 15:31'!
testCalcularAngulo3
	| robot ang |
	robot := RobotExample new.
	ang := robot getAngle: 0 @ 10.
	self
		should: [ang degrees closeTo: 90]! !

!RobotExampleTest methodsFor: 'calcularAngulo' stamp: 'Richo 10/25/2010 15:30'!
testCalcularAngulo4
	| robot ang |
	robot := RobotExample new.
	ang := robot getAngle: -10 @ -10.
	self
		should: [ang degrees closeTo: -135]! !

!RobotExampleTest methodsFor: 'calcularAngulo' stamp: 'Richo 10/25/2010 15:30'!
testCalcularAngulo5
	| robot ang |
	robot := RobotExample new.
	ang := robot getAngle: -10 @ 10.
	self
		should: [ang degrees closeTo: 135]! !

!RobotExampleTest methodsFor: 'calcularAngulo' stamp: 'Richo 10/25/2010 15:31'!
testCalcularAngulo6
	| robot ang |
	robot := RobotExample new.
	ang := robot getAngle: 0 @ -10.
	self
		should: [ang degrees closeTo: -90]! !

!RobotExampleTest methodsFor: 'calcularAngulo' stamp: 'Richo 10/25/2010 15:31'!
testCalcularAngulo7
	| robot ang |
	robot := RobotExample new.
	ang := robot getAngle: -10 @ 0.
	self
		should: [ang degrees closeTo: 180]! !

!RobotExampleTest methodsFor: 'cuadranteDe' stamp: 'Richo 10/25/2010 15:30'!
testCuadranteDe
	| robot cuadrante |
	robot := RobotExample new.
	robot position: 0 @ 0.
	cuadrante := robot quadrant: 10 @ 10.
	self
		should: [cuadrante = 1].
	cuadrante := robot quadrant: -10 @ 10.
	self
		should: [cuadrante = 2].
	cuadrante := robot quadrant: -10 @ -10.
	self
		should: [cuadrante = 3].
	cuadrante := robot quadrant: 10 @ -10.
	self
		should: [cuadrante = 4]! !

!RobotExampleTest methodsFor: 'estaDelLado' stamp: 'Richo 10/25/2010 15:30'!
testEstaDelLado
	| robot obj |
	robot := RobotExample new.
	robot
		rotation: (Angle degrees: 45).
	robot position: 0 @ 0.
	obj := 10 @ 0.
	self
		shouldnt: [robot isLookingTo: obj].
	self
		should: [robot isInTheRightSide: obj]! !

!RobotExampleTest methodsFor: 'estaDelLado' stamp: 'Richo 10/25/2010 15:31'!
testEstaDelLado10
	| robot obj |
	robot := RobotExample new.
	robot
		rotation: (Angle degrees: 0).
	robot position: 0 @ 0.
	obj := 0 @ 10.
	self
		shouldnt: [robot isLookingTo: obj].
	self
		shouldnt: [robot isInTheRightSide: obj]! !

!RobotExampleTest methodsFor: 'estaDelLado' stamp: 'Richo 10/25/2010 15:31'!
testEstaDelLado11
	| robot obj |
	robot := RobotExample new.
	robot
		rotation: (Angle degrees: 90).
	robot position: 0 @ 0.
	obj := 10 @ -10.
	self
		shouldnt: [robot isLookingTo: obj].
	self
		should: [robot isInTheRightSide: obj]! !

!RobotExampleTest methodsFor: 'estaDelLado' stamp: 'Richo 10/25/2010 15:31'!
testEstaDelLado12
	| robot obj |
	robot := RobotExample new.
	robot
		rotation: (Angle degrees: 135).
	robot position: 0 @ 0.
	obj := 10 @ -1.
	self
		shouldnt: [robot isLookingTo: obj].
	self
		should: [robot isInTheRightSide: obj]! !

!RobotExampleTest methodsFor: 'estaDelLado' stamp: 'Richo 10/25/2010 15:30'!
testEstaDelLado13
	| robot obj |
	robot := RobotExample new.
	robot
		rotation: (Angle degrees: -135).
	robot position: 0 @ 0.
	obj := 10 @ -1.
	self
		shouldnt: [robot isLookingTo: obj].
	self
		shouldnt: [robot isInTheRightSide: obj]! !

!RobotExampleTest methodsFor: 'estaDelLado' stamp: 'Richo 10/25/2010 15:31'!
testEstaDelLado14
	| robot obj |
	robot := RobotExample new.
	robot
		rotation: (Angle degrees: 0).
	robot position: 0 @ 0.
	obj := 0 @ 10.
	self
		shouldnt: [robot isLookingTo: obj].
	self
		shouldnt: [robot isInTheRightSide: obj]! !

!RobotExampleTest methodsFor: 'estaDelLado' stamp: 'Richo 10/25/2010 15:31'!
testEstaDelLado15
	| robot obj |
	robot := RobotExample new.
	robot
		rotation: (Angle degrees: 0).
	robot position: 0 @ 0.
	obj := 0 @ -10.
	self
		shouldnt: [robot isLookingTo: obj].
	self
		should: [robot isInTheRightSide: obj]! !

!RobotExampleTest methodsFor: 'estaDelLado' stamp: 'Richo 10/25/2010 15:31'!
testEstaDelLado2
	| robot obj |
	robot := RobotExample new.
	robot
		rotation: (Angle degrees: 45).
	robot position: 0 @ 0.
	obj := -10 @ 0.
	self
		shouldnt: [robot isLookingTo: obj].
	self
		shouldnt: [robot isInTheRightSide: obj]! !

!RobotExampleTest methodsFor: 'estaDelLado' stamp: 'Richo 10/25/2010 15:30'!
testEstaDelLado3
	| robot obj |
	robot := RobotExample new.
	robot
		rotation: (Angle degrees: 90).
	robot position: 0 @ 0.
	obj := -10 @ 0.
	self
		shouldnt: [robot isLookingTo: obj].
	self
		shouldnt: [robot isInTheRightSide: obj]! !

!RobotExampleTest methodsFor: 'estaDelLado' stamp: 'Richo 10/25/2010 15:31'!
testEstaDelLado4
	| robot obj |
	robot := RobotExample new.
	robot
		rotation: (Angle degrees: 90).
	robot position: 0 @ 0.
	obj := 10 @ 0.
	self
		shouldnt: [robot isLookingTo: obj].
	self
		should: [robot isInTheRightSide: obj]! !

!RobotExampleTest methodsFor: 'estaDelLado' stamp: 'Richo 10/25/2010 15:30'!
testEstaDelLado5
	| robot obj |
	robot := RobotExample new.
	robot
		rotation: (Angle degrees: -90).
	robot position: 0 @ 0.
	obj := -10 @ 0.
	self
		shouldnt: [robot isLookingTo: obj].
	self
		should: [robot isInTheRightSide: obj]! !

!RobotExampleTest methodsFor: 'estaDelLado' stamp: 'Richo 10/25/2010 15:31'!
testEstaDelLado6
	| robot obj |
	robot := RobotExample new.
	robot
		rotation: (Angle degrees: 45).
	robot position: 0 @ 0.
	obj := 0 @ 10.
	self
		shouldnt: [robot isLookingTo: obj].
	self
		shouldnt: [robot isInTheRightSide: obj]! !

!RobotExampleTest methodsFor: 'estaDelLado' stamp: 'Richo 10/25/2010 15:31'!
testEstaDelLado7
	| robot obj |
	robot := RobotExample new.
	robot
		rotation: (Angle degrees: -90).
	robot position: 0 @ 0.
	obj := 10 @ 0.
	self
		shouldnt: [robot isLookingTo: obj].
	self
		shouldnt: [robot isInTheRightSide: obj]! !

!RobotExampleTest methodsFor: 'estaDelLado' stamp: 'Richo 10/25/2010 15:31'!
testEstaDelLado8
	| robot obj |
	robot := RobotExample new.
	robot
		rotation: (Angle degrees: -45).
	robot position: 0 @ 0.
	obj := 0 @ -10.
	self
		shouldnt: [robot isLookingTo: obj].
	self
		should: [robot isInTheRightSide: obj]! !

!RobotExampleTest methodsFor: 'estaDelLado' stamp: 'Richo 10/25/2010 15:31'!
testEstaDelLado9
	| robot obj |
	robot := RobotExample new.
	robot
		rotation: (Angle degrees: 135).
	robot position: 0 @ 0.
	obj := -10 @ 0.
	self
		shouldnt: [robot isLookingTo: obj].
	self
		shouldnt: [robot isInTheRightSide: obj]! !

!RobotExampleTest methodsFor: 'mirandoA' stamp: 'Richo 10/25/2010 15:30'!
testMirandoA
	| robot |
	robot := RobotExample new.
	robot
		rotation: (Angle degrees: 45).
	robot position: 0 @ 0.
	self
		should: [robot isLookingTo: 10 @ 10].
	self
		shouldnt: [robot lookInFrontOf: -10 @ 10]! !

!RobotExampleTest methodsFor: 'mirandoA' stamp: 'Richo 10/25/2010 15:30'!
testMirandoA10
	| robot |
	robot := RobotExample new.
	robot
		rotation: (Angle degrees: 179).
	robot position: 0 @ 0.
	self
		should: [robot isLookingTo: -10 @ 0].
	self
		shouldnt: [robot lookInFrontOf: -10 @ 10]! !

!RobotExampleTest methodsFor: 'mirandoA' stamp: 'Richo 10/25/2010 15:31'!
testMirandoA2
	| robot |
	robot := RobotExample new.
	robot
		rotation: (Angle degrees: 1).
	robot position: 0 @ 0.
	self
		should: [robot isLookingTo: 10 @ 0].
	self
		shouldnt: [robot lookInFrontOf: -10 @ 10]! !

!RobotExampleTest methodsFor: 'mirandoA' stamp: 'Richo 10/25/2010 15:31'!
testMirandoA3
	| robot |
	robot := RobotExample new.
	robot
		rotation: (Angle degrees: 1).
	robot position: 0 @ 0.
	self
		should: [robot isLookingTo: 10 @ 0].
	self
		shouldnt: [robot lookInFrontOf: -10 @ 10]! !

!RobotExampleTest methodsFor: 'mirandoA' stamp: 'Richo 10/25/2010 15:31'!
testMirandoA4
	| robot |
	robot := RobotExample new.
	robot
		rotation: (Angle degrees: 90).
	robot position: 0 @ 0.
	self
		should: [robot isLookingTo: 0 @ -10].
	self
		should: [robot isLookingTo: 0 @ 10]! !

!RobotExampleTest methodsFor: 'mirandoA' stamp: 'Richo 10/25/2010 15:31'!
testMirandoDeEspaldasA1
	| robot |
	robot := RobotExample new.
	robot
		rotation: (Angle degrees: 179).
	robot position: 0 @ 0.
	self
		should: [robot lookBackwardsTo: 10 @ 0].
	self
		shouldnt: [robot lookBackwardsTo: -10 @ 10]! !

!RobotExampleTest methodsFor: 'mirandoA' stamp: 'Richo 10/25/2010 15:31'!
testMirandoDeEspaldasA2
	| robot |
	robot := RobotExample new.
	robot
		rotation: (Angle degrees: 1).
	robot position: 0 @ 0.
	self
		should: [robot lookBackwardsTo: -10 @ 0].
	self
		shouldnt: [robot lookBackwardsTo: -10 @ 10]! !

!RobotExampleTest methodsFor: 'mirandoA' stamp: 'Richo 10/25/2010 15:31'!
testMirandoDeEspaldasA3
	| robot |
	robot := RobotExample new.
	robot
		rotation: (Angle degrees: 179).
	robot position: 0 @ 0.
	self
		should: [robot lookBackwardsTo: 10 @ 0].
	self
		shouldnt: [robot lookBackwardsTo: -10 @ 10]! !

!RobotExampleTest methodsFor: 'mirandoA' stamp: 'Richo 10/25/2010 15:30'!
testMirandoDeEspaldasA4
	| robot |
	robot := RobotExample new.
	robot
		rotation: (Angle degrees: 179).
	robot position: 0 @ 0.
	self
		should: [robot lookBackwardsTo: 10 @ 0].
	self
		shouldnt: [robot lookBackwardsTo: -10 @ 10]! !

!RobotExampleTest methodsFor: 'mirandoA' stamp: 'Richo 10/25/2010 15:31'!
testMirandoDeEspaldasA5
	| robot |
	robot := RobotExample new.
	robot
		rotation: (Angle degrees: 1).
	robot position: 0 @ 0.
	self
		should: [robot lookBackwardsTo: -10 @ 0].
	self
		shouldnt: [robot lookBackwardsTo: -10 @ 10]! !

!RobotExampleTest methodsFor: 'mirandoA' stamp: 'Richo 10/25/2010 15:31'!
testMirandoDeFrenteA
	| robot |
	robot := RobotExample new.
	robot
		rotation: (Angle degrees: 45).
	robot position: 0 @ 0.
	self
		should: [robot lookInFrontOf: 10 @ 10].
	self
		shouldnt: [robot lookInFrontOf: -10 @ 10]! !

!RobotExampleTest methodsFor: 'mirandoA' stamp: 'Richo 10/25/2010 15:31'!
testMirandoDeFrenteA10
	| robot |
	robot := RobotExample new.
	robot
		rotation: (Angle degrees: 179).
	robot position: 0 @ 0.
	self
		should: [robot lookInFrontOf: -10 @ 0].
	self
		shouldnt: [robot lookInFrontOf: -10 @ 10]! !

!RobotExampleTest methodsFor: 'mirandoA' stamp: 'Richo 10/25/2010 15:30'!
testMirandoDeFrenteA2
	| robot |
	robot := RobotExample new.
	robot
		rotation: (Angle degrees: 1).
	robot position: 0 @ 0.
	self
		should: [robot lookInFrontOf: 10 @ 0].
	self
		shouldnt: [robot lookInFrontOf: -10 @ 10]! !

!RobotExampleTest methodsFor: 'mirandoA' stamp: 'Richo 10/25/2010 15:31'!
testMirandoDeFrenteA3
	| robot |
	robot := RobotExample new.
	robot
		rotation: (Angle degrees: 1).
	robot position: 0 @ 0.
	self
		should: [robot lookInFrontOf: 10 @ 0].
	self
		shouldnt: [robot lookInFrontOf: -10 @ 10]! !

!RobotExampleTest methodsFor: 'mirandoA' stamp: 'Richo 10/25/2010 15:30'!
testMirandoDeFrenteA4
	| robot |
	robot := RobotExample new.
	robot
		rotation: (Angle degrees: 90).
	robot position: 0 @ 0.
	self
		shouldnt: [robot lookInFrontOf: 0 @ -10].
	self
		should: [robot lookInFrontOf: 0 @ 10]! !

TestCase subclass: #ViewerMorphTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Tests'!

!ViewerMorphTest methodsFor: 'as yet unclassified' stamp: 'Richo 10/25/2010 15:29'!
testAngleConversion
	| angSimu angSqueak |
	angSimu := 90.
	angSqueak := BoardMorph squeakAngle: angSimu.
	self
		should: [angSqueak = 0]! !

!ViewerMorphTest methodsFor: 'as yet unclassified' stamp: 'Richo 10/25/2010 15:29'!
testAngleConversion2
	| angSimu angSqueak |
	angSimu := 0.
	angSqueak := BoardMorph squeakAngle: angSimu.
	self
		should: [angSqueak = 90]! !

!ViewerMorphTest methodsFor: 'as yet unclassified' stamp: 'Richo 10/25/2010 15:29'!
testAngleConversion3
	| angSimu angSqueak |
	angSimu := -179.
	angSqueak := BoardMorph squeakAngle: angSimu.
	self
		should: [angSqueak = -91]! !

!ViewerMorphTest methodsFor: 'as yet unclassified' stamp: 'Richo 10/25/2010 15:29'!
testAngleConversion4
	| angSimu angSqueak |
	angSimu := 179.
	angSqueak := BoardMorph squeakAngle: angSimu.
	self
		should: [angSqueak = -89]! !
